var phoenix_theFile;
var phoenix_last_file_saved;
var phoenix_history = new Array();
var phoenix_history_pointer = 0;
var phoenix_history_capture = true;

function phoenix_editorInit ()
{
	document.getElementById('phoenixIFrame').contentWindow.document.designMode = "on";
	window.removeEventListener("load", phoenix_editorInit, true);
	phoenix_setInitialPrefs ();
	phoenix_test_allowed ();

	var obj = document.getElementById('phoenixIFrame').contentWindow.document.body;
	phoenix_line_numbers_set (obj);

	document.getElementById('bottom_console').contentWindow.document.getElementById('ToolbarEval').style.display = "none";
	document.getElementById('url').style.width = (phoenix_prefs.getCharPref('width') - phoenix_urlbar_adjust) + "px";

	// https://developer.mozilla.org/en/Using_the_Clipboard
	// document.getElementById('phoenixIFrame').contentWindow.document.addEventListener("paste", pasteIntercept, false);

	if (window.arguments[0] != undefined || window.arguments[2] != undefined)
		phoenix_put_code ('');

	if (window.arguments[0] != undefined)
	{
		document.getElementById('url').value = window.arguments[0];
		document.getElementById('showHeaders').setAttribute('disabled', false);
	}

	else
	{
		document.getElementById('showHeaders').setAttribute('disabled', true);
	}

	if (window.arguments[1] == undefined)
		window.arguments[1] = 'js';

	if (window.arguments[0] != undefined && Application.storage.has(phoenix_md5 ('file' + window.arguments[0])))
		phoenix_put_code (Application.storage.get(phoenix_md5 ('file' + window.arguments[0]), false));

	else if (window.arguments[2] != undefined)
		phoenix_put_code (window.arguments[2]);

	else if (window.arguments[0] != undefined)
		phoenix_importFile (window.arguments[0]);

	if (window.arguments[0] == '' || window.arguments[1] == 'html')
		document.getElementById('reload-button').disabled = true;

	phoenix_setEditor (window.arguments[1]);
	phoenix_editor_main ();
	phoenix_editorFocus ();
}


function phoenix_editor_main ()
{
	if (phoenix_this_url_allowed) {
        //get a reference to all dom windows in current page
        var wins = phoenix_getFrames();

		var js = phoenix_getJS (wins);
		var css = phoenix_getCSS (wins);
		document.getElementById('menu-js').setAttribute('disabled', false);
		document.getElementById('menu-css').setAttribute('disabled', false);

		if (js.length >= 1)
			document.getElementById('menu-js').setAttribute('label', phoenix_getStr('phoenix.javascript') + " (" + js.length + ")");

		else
			document.getElementById('menu-js').setAttribute('disabled', true);

		if (css.length >= 1)
			document.getElementById('menu-css').setAttribute('label', phoenix_getStr('phoenix.css') + " (" + css.length + ")");

		else
			document.getElementById('menu-css').setAttribute('disabled', true);
	}
	else
	{
		document.getElementById('menu-js').setAttribute('disabled', true);
		document.getElementById('menu-css').setAttribute('disabled', true);
	}
}


function phoenix_evalDocument ()
{
	var code = document.getElementById('phoenixIFrame').contentWindow.document.body.textContent;

	if (window.arguments[1] == 'js')
	{
		// this bit is a pain in the ass
		// we need to find a way to get rid of comments and
		// this complex workaround is the only one i could think of
		code = document.getElementById('phoenixIFrame').contentWindow.document.body.innerHTML; // the textContent does not capture \n
		code = code.replace(/<\/li>/mig, "\n"); //
		code = code.replace(/<br[^>]?>/mig, "\n"); //
		code = code.replace(/\/\/[^\n]*\n/g, ''); // strip // comments
		code = code.replace(/\/\*([^\/])*\*\//mg, ''); // strip /* */ comments
		code = code.replace(/<[^>]*>/mig, '');
		code = phoenix_unescapeHTML (code);
		//code = code.replace(/<\S[^><]*>/mig, '');
		window.opener.content.document.location = "javascript:" + code.replace(/%/g, "%25");
	}

	else if (window.arguments[1] == 'css')
	{
		// first remove linked stylesheets
		elems = window.opener.content.document.getElementsByTagName('link');
		for (i = 0; i < elems.length; i++)
		{
			stylesheet = elems[i];
			if (stylesheet.href == window.arguments[0])
				stylesheet.parentNode.removeChild(stylesheet);
		}

		// second remove embedded styles
		elems = window.opener.content.document.getElementsByTagName('style');
		for (i = 0; i < elems.length; i++)
		{
			stylesheet = elems[i];
			if (stylesheet.title == "Phoenix")
				stylesheet.parentNode.removeChild(stylesheet);
		}

		// third add your styles
		var el = window.opener.content.document.createElement('style');
		el.setAttribute('title', 'Phoenix');
		el.setAttribute('type', 'text/css');
		el.innerHTML = phoenix_unescapeHTML (code);
		window.opener.content.document.getElementsByTagName("head")[0].appendChild(el);
	}

	else if (window.arguments[1] == 'html')
	{
		code = phoenix_unescapeHTML (code);
		// really complex regexp: took me ages to figure this one out
		// http://www.experts-exchange.com/Programming/phoenix_Languages/Regular_Expressions/Q_23008284.html
		var re = new RegExp('<body[^>]*>([\\S\\s]*)<\\/body>', 'mig');
		var matches = code.match(re);
		code = matches[0].replace(/<body[^>]*>/mig, '').replace(/<\/body>/mig, '');

		window.opener.content.document.getElementsByTagName("body")[0].innerHTML = code;
	}
}

function phoenix_openConsole () {
	phoenix_prefs = phoenix_getPrefs ();

	if (phoenix_prefs.getBoolPref('openDocked'))
	{
		if (phoenix_prefs.getBoolPref('showErrorConsole'))
		{
			phoenix_saveConsoleSize ();
			var showConsole = 'none';
			phoenix_prefs.setBoolPref('showErrorConsole', false);
		}

		else
		{
			document.getElementById('bottom_console').contentWindow.document.getElementById('ToolbarEval').style.display = "none";
			document.getElementById('bottom_console').setAttribute('height', phoenix_prefs.getIntPref('ErrorConsoleHeight'));
			var showConsole = 'block';
			phoenix_prefs.setBoolPref('showErrorConsole', true);
		}

		document.getElementById('bottom_splitter').style.display = showConsole;
		document.getElementById('bottom_console').style.display = showConsole;
	}

	else
	{
		window.opener.toJavaScriptConsole();

		var phoenix_prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
		phoenix_prefs = phoenix_prefs.getBranch('javascript.options.');
		phoenix_prefs.setBoolPref('showInConsole', true);
	}
}


function phoenix_beautify (what)
{
	if (window.arguments[1] == 'css')
	{
		var code = phoenix_beautify_css (what);
		phoenix_editorFocus ();
		return (code);
	}

	if (window.arguments[1] == 'js' || window.arguments[1] == 'html')
	{
		var code = phoenix_beautify_js (what);
		phoenix_editorFocus ();
		return (code);
	}
}


function phoenix_beautify_js (what)
{
    // http://jsbeautifier.org/
	var js_source = phoenix_get_code ();
	var indent_size = 4;
	var indent_char = ' ';
	var preserve_newlines = true;

	if (js_source && js_source[0] === '<')
		var code = phoenix_style_html(js_source, indent_size, indent_char, 999);

	else
		var code = phoenix_js_beautify(phoenix_unpacker_filter(js_source), {indent_size: indent_size, indent_char: indent_char, preserve_newlines:preserve_newlines});

	if (what == 'eval')
		phoenix_put_code (code);

	else if (what == 'code')
		return (code);

	return (false);
}


function phoenix_unpacker_filter (source)
{
	var pattern = /eval\(function\(p,a,c,k.*?,0,\{\}\)\)/mi;
	var m = source.match(pattern);
	if (m != null)
	{
		try {
			// https://developer.mozilla.org/En/Components.utils.evalInSandbox
			var s = Components.utils.Sandbox('about:blank');
			var unpacked_source = Components.utils.evalInSandbox(m[0].slice(4) + ';', s);
			//eval('var unpacked_source = ' + m[0].substring(4) + ';'); // my old version
			//eval("var unpacked_source = String" + m[0].slice(4)); // dean edwards version
			source = source.replace(pattern, unpacked_source);
			return phoenix_unpacker_filter (source)
		}
		catch (error) {
			source = '// formatting code: unpacking failed\n// ' + error + "\n" + source;
		}
	}

	return (source);
}


function phoenix_minify ()
{
	if (window.arguments[1] == 'css')
	{
		var code = phoenix_get_code ();
		code = code.replace(/\s+/mig, ' ');
		code = code.replace(/\/\*.*?\*\//mig, '');
		code = code.replace(/\s?{\s?/mig, '{');
		code = code.replace(/\s?}\s?/mig, '}');
		code = code.replace(/\s?;\s?/mig, ';');
		code = code.replace(/\s?:\s?/mig, ':');
		code = code.replace(/^\s+/mig, '');

		phoenix_put_code (code);
	}

	if (window.arguments[1] == 'js')
	{
		var code = phoenix_get_code ();
		code = phoenix_jsmin ('', code, 3);
		phoenix_put_code (code);
	}

	phoenix_editorFocus ();
}


function phoenix_pack ()
{
	var code = phoenix_get_code ();
	code = new Packer().pack(code, true, true);
	phoenix_put_code (code);
	phoenix_editorFocus ();
}


function phoenix_show_headers ()
{
	var url = document.getElementById('url').value;
	alert (Application.storage.get(phoenix_md5 ('headers' + url), false));
}


function phoenix_reloadExec ()
{
	if (window.arguments[1] == 'css')
	{
		var url = document.getElementById('url').value;
		var i, elems, stylesheet;

		elems = window.opener.content.document.getElementsByTagName('link');
		for (i = 0; i < elems.length; i++)
		{
			stylesheet = elems[i];
			if (stylesheet.href.indexOf(phoenix_getFileName (url)))
			{
				stylesheet.href = stylesheet.href + (stylesheet.href.indexOf('?') >= 0 ? '&' : '?') + 'forceReload=' + (new Date().valueOf());

				phoenix_viewSource (url, "css", "current");
				phoenix_editorFocus ();
				alert (phoenix_getStr('phoenix.reloaded') + phoenix_getFileName (url));
				return (false);
			}
		}
	}

	if (window.arguments[1] == 'js')
	{
		var url = document.getElementById('url').value;
		var elems = window.opener.content.document.getElementsByTagName('script');

		for (var i = 0; i < elems.length; i++)
		{
			var js = elems[i];
			if (js.src == url)
			{
				js.parentNode.removeChild(js);

				var el = window.opener.content.document.createElement('script');
				el.setAttribute('src', url);
				el.setAttribute('type', 'text/javascript');
				window.opener.content.document.getElementsByTagName("head")[0].appendChild(el);

				phoenix_viewSource (url, "js", "current");
				phoenix_editorFocus ();
				alert (phoenix_getStr('phoenix.reloaded') + phoenix_getFileName (url));
				return (false);
			}
		}
	}
}


// https://developer.mozilla.org/En/XUL/PopupGuide/Menus

// https://developer.mozilla.org/en/nsIFilePicker
// https://developer.mozilla.org/En/XUL_Tutorial/Open_and_Save_Dialogs
// https://developer.mozilla.org/index.php?title=En/Code_snippets/File_I%2F%2FO
function phoenix_FilePicker (aTitle, aSave)
{
	var retVal = null;
	try {
		const nsIFilePicker = Components.interfaces.nsIFilePicker;
		var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
		fp.init(window, aTitle, (aSave ? nsIFilePicker.modeSave : nsIFilePicker.modeOpen));

		if (window.arguments[1] == "css")
			fp.appendFilter("Stylesheet", "*.css");

		if (window.arguments[1] == "html")
			fp.appendFilter("HTML", "*.htm; *.html");

		if (window.arguments[1] == "js")
			fp.appendFilter("JavaScript", "*.js");

		fp.appendFilters(nsIFilePicker.filterAll | nsIFilePicker.filterText);

		if (aSave && document.getElementById('url').value != '')
			fp.defaultString = phoenix_getFileName (document.getElementById('url').value);

		var result = fp.show();

		if (result == nsIFilePicker.returnOK || result == nsIFilePicker.returnReplace)
			retVal = fp.file;

	}
	catch (ex) {}

	return (retVal);
}

function phoenix_loadFile ()
{
	const inputStream = Components.classes["@mozilla.org/network/file-input-stream;1"].createInstance(Components.interfaces.nsIFileInputStream);
	const scriptableStream = Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance(Components.interfaces.nsIScriptableInputStream);
	phoenix_theFile = phoenix_FilePicker("Open file", 0);
	inputStream.init(phoenix_theFile, 0x01, 0666, null);
	scriptableStream.init(inputStream);
	var code = scriptableStream.read(scriptableStream.available());
	phoenix_put_code (code);
	scriptableStream.close();
	inputStream.close();

	document.getElementById('url').value = phoenix_theFile.path;
	var filePath = phoenix_theFile.path;

	if (filePath.match(/\.css$/))
		phoenix_setEditor ('css');

	else if (filePath.match(/\.js$/))
		phoenix_setEditor ('js');

	else if (filePath.match(/\.html$/) || filePath.match(/\.html$/))
		phoenix_setEditor ('html');

	phoenix_textChanged ();
	phoenix_editorFocus ();
}


function phoenix_saveFile ()
{
	if (!phoenix_theFile.exists() || phoenix_last_file_saved != phoenix_getFileName (document.getElementById('url').value))
	{
		phoenix_saveFileAs ();
	}
	else
	{
		const outputStream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
		var data = document.getElementById('phoenixIFrame').contentWindow.document.body.innerHTML; // the textContent does not capture \n
		data = data.replace(/<\/li>/mig, "\n"); //
		data = data.replace(/<br[^>]?>/mig, "\n"); //
		data = data.replace(/<[^>]*>/mig, '');
		data = phoenix_unescapeHTML (data);
		outputStream.init(phoenix_theFile, 0x04 | 0x08 | 0x20, 0666, null);
		outputStream.write(data, data.length);
		outputStream.close();

		phoenix_textChanged ();
	}
}


function phoenix_saveFileAs ()
{
	const outputStream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
	var data = document.getElementById('phoenixIFrame').contentWindow.document.body.innerHTML; // the textContent does not capture \n
	data = data.replace(/<\/li>/mig, "\n"); //
	data = data.replace(/<br[^>]?>/mig, "\n"); //
	data = data.replace(/<[^>]*>/mig, '');
	data = phoenix_unescapeHTML (data);
	phoenix_theFile = phoenix_FilePicker(phoenix_getStr('phoenix.saveFileAs'), 1);
	if (!phoenix_theFile.exists())
		phoenix_theFile.create(Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 666);

	outputStream.init(phoenix_theFile, 0x04 | 0x08 | 0x20, 0666, null);
	outputStream.write(data, data.length);
	outputStream.close();

	var filename = phoenix_theFile.path;
	phoenix_last_file_saved = filename.substring(filename.lastIndexOf('\\') + 1);

	phoenix_textChanged ();
}


function phoenix_textChanged ()
{
	try {
		if (phoenix_theFile.exists())
			window.document.getElementById('phoenixMenuSave').setAttribute('disabled', 'false');
	}
	catch(e) {}

	return (false);
}


function phoenix_editorFocus ()
{
	if (phoenix_prefs.getBoolPref('syntaxHighlighting') == true)
		setTimeout("document.getElementById('phoenixIFrame').contentWindow.phoenix_CodePress.syntaxHighlight('generic')", 300);
}


function phoenix_toggleFindbar ()
{
	if (document.getElementById('findbar').style.display == "block")
	{
		document.getElementById('search').className = "find_ok";
		document.getElementById('search').value = '';
		document.getElementById('findbar').style.display = "none";
		phoenix_editorFocus ();
	}
	else
	{
		document.getElementById('search').addEventListener("keyup", phoenix_find, true);
        document.getElementById('search').phoenix_find_added = true;

		document.getElementById('findbar').style.display = "block";
		document.getElementById('search').focus();
		document.getElementById('search').addEventListener("focus", phoenix_find, true);
		document.getElementById('find-next').disabled = true;
		document.getElementById('find-prev').disabled = true;
	}
}


// https://developer.mozilla.org/en/DOM/Event/UIEvent/KeyEvent
function phoenix_editor_keypress (e)
{
	phoenix_history_capture = false;
	if (e.charCode == 122 && e.ctrlKey) // ctrl+z
		phoenix_undo (e);

	else if (e.charCode == 121 && e.ctrlKey) // ctrl+y
		phoenix_redo (e);

	else if (e.charCode == 102 && e.ctrlKey) // ctrl+f
		phoenix_toggleFindbar ();

	else if (e.keyCode == e.DOM_VK_F3) // f3
		phoenix_next_find ();

	else
		phoenix_history_capture = true;
}


function phoenix_editor_keyup (e)
{
	if (phoenix_history_capture == true)
	{
		var code = document.getElementById('phoenixIFrame').contentWindow.document.body.innerHTML.replace(/^\s+/, '');
		phoenix_history[phoenix_history.length] = phoenix_unescapeHTML (code);
		phoenix_history_pointer = phoenix_history_pointer + 1;
	}
}


function phoenix_undo (e)
{
	e.cancelBubble = true;
	if (phoenix_history_pointer >= 1)
	{
		var code = phoenix_history[phoenix_history_pointer - 1];
		document.getElementById('phoenixIFrame').contentWindow.document.body.innerHTML = code;
		phoenix_history_pointer = phoenix_history_pointer - 1;
	}
}


function phoenix_redo (e)
{
	e.cancelBubble = true;
	if (phoenix_history_pointer < phoenix_history.length)
	{
		var code = phoenix_history[phoenix_history_pointer + 1];
		document.getElementById('phoenixIFrame').contentWindow.document.body.innerHTML = code;
		phoenix_history_pointer = phoenix_history_pointer + 1;
	}
}


function phoenix_calculateSize ()
{
	var code = phoenix_get_code ();
	var len = phoenix_formatSize (code.length);
	var gzipped = phoenix_lzw_encode (code);
	var gzipped_len = phoenix_formatSize (gzipped.length);
	alert (phoenix_getStr('phoenix.thisFileSize') + " " + len + "\n" + phoenix_getStr('phoenix.gzippedSize') + " " + gzipped_len);
}


// https://developer.mozilla.org/En/XUL/Events
window.addEventListener("load", phoenix_editorInit, true);
window.addEventListener("unload", phoenix_saveConsoleSize, true);
window.addEventListener("resize", phoenix_saveSize, true);
window.addEventListener("keypress", phoenix_editor_keypress, true);
window.addEventListener("keyup", phoenix_editor_keyup, true);
window.addEventListener("focus", phoenix_test_allowed, true);
