// "C:\Program Files\Mozilla Firefox\firefox.exe" -safe-mode

var phoenix_prefs;
var phoenix_urlbar_adjust = 106;
var phoenix_find_pointer = 0;
var phoenix_find_matches = 0;
var phoenix_this_url_allowed = false;
var phoenix_cache = phoenix_getCacheService();
var phoenix_total_files = 0;


function phoenix_test_allowed()
{
    var start = false;
    var url_list = '';

    try {
        var phoenix_url = window.content.document.domain;
    } catch(e) {
        try {
            var phoenix_url = window.opener.content.document.domain;
        }
        catch (e2) {
        }
    }

    try {
        if (phoenix_prefs.getIntPref('allowedUrls') == "0")
        {
            start = true;
            var temp_list = phoenix_trim(phoenix_prefs.getCharPref('allowedtextall'));
            url_list = temp_list.split("\n");
            for (var i = 0; i < url_list.length; i++)
            {
                if (phoenix_url.indexOf(url_list[i]) >= 0)
                {
                    start = false;
                    break;
                }
            }
        }

        else
        {
            start = false;
            var temp_list = phoenix_trim(phoenix_prefs.getCharPref('allowedtextnone'));
            url_list = temp_list.split("\n");

            for (i = 0; i < url_list.length; i++)
            {
                if (phoenix_url.indexOf(url_list[i]) >= 0)
                {
                    start = true;
                    break;
                }
            }
        }
    } catch(e) {
    }

    try {
        var obj = window.opener.document;
    } catch (e) {
        var obj = document;
    }

    if (start && url_list != '' && url_list != null) {
        try {
            phoenix_this_url_allowed = true;
            obj.getElementById('phoenix-status-label').setAttribute('disabled', false);
            obj.getElementById('phoenix-context').setAttribute('disabled', false);
            obj.getElementById('phoenix-tooltip').setAttribute('hidden', false);

//            consoleService.logStringMessage("-> start: " + start);
            //            consoleService.logStringMessage("-> url_list: " + url_list);

            phoenix_main();
        }
        catch (e) {
            try {
                phoenix_editor_main();
            }
            catch (e2) {
            }
        }
    }
    else
    {
        try {
            phoenix_this_url_allowed = false;
            obj.getElementById('phoenix-status').image = "chrome://phoenix/skin/images/icon.png";
            obj.getElementById('phoenix-status-label').setAttribute('value', phoenix_getStr('phoenix.zeroFiles'));
            obj.getElementById('phoenix-status-label').setAttribute('disabled', true);
            obj.getElementById('phoenix-context').setAttribute('value', phoenix_getStr('phoenix.zeroFiles'));
            obj.getElementById('phoenix-context').setAttribute('disabled', true);
            obj.getElementById('phoenix-tooltip').setAttribute('hidden', true);
        }
        catch (e) {
            try {
                obj.getElementById('menu-css').setAttribute('label', phoenix_getStr('phoenix.css'));
                obj.getElementById('menu-css').setAttribute('disabled', true);
                obj.getElementById('menu-js').setAttribute('label', phoenix_getStr('phoenix.javascript'));
                obj.getElementById('menu-js').setAttribute('disabled', true);
            }
            catch (e2) {
            }
        }
    }
}

function phoenix_makeMenu(menu, type, where, origin)
{
    //https://developer.mozilla.org/En/XUL/PopupGuide/MenuItems
    while (menu.firstChild)
        menu.removeChild(menu.firstChild);

    if (phoenix_this_url_allowed)
    {
        var attrs;
        //get a reference to all dom windows in current page
        var wins = phoenix_getFrames();

        var js = phoenix_getJS(wins);
        var css = phoenix_getCSS(wins);
        var cache = phoenix_cache;

        // we need this to understand if we need to check for packed/minified files
        phoenix_total_files = js.length + css.length;

        if (js.length > 0 && (type == 'all' || type == 'js'))
        {
            var total_js_size = 0;
            if ((type == 'all' || type == 'js') && phoenix_prefs.getBoolPref('multipleInstances') == true)
            {
                attrs = ['menuitem',
                    ['id', 'js-id-' + origin],
                    ['oncommand', 'phoenix_viewAll("js", "' + where + '");'],
                    ['style','font-weight:bold'],
                    ['tooltiptext', phoenix_getStr('phoenix.openAllJS')]];
                menu.appendChild(phoenix_makeElement(attrs));
            }

            else if ((type == 'all' || type == 'js') && origin != 'editor')
            {
                attrs = ['menuitem',
                    ['id', 'js-id-' + origin],
                    ['style','font-weight:bold'],
                    ['tooltiptext', '']];
                menu.appendChild(phoenix_makeElement(attrs));
            }


            for (var i = 0; i < js.length; ++i)
            {
                var filename = phoenix_getFileName(js[i], 'js');
                var data = phoenix_getFileSize(null, cache, js[i], false);
                var italics = (js[i].match(/^chrome/) || js[i].match(/^resource/)) ? " italics" : "";
                var tooltip = new Array();
                var txt = new Array();
                var j = 0;

                if (phoenix_isInt(data[1]))
                    total_js_size += data[1] * 1;

                if (data[2] == true)
                {
                    tooltip[j] = "Cached";
                    txt[j] = "c";
                    j++;
                }

                if (data[3] == true)
                {
                    tooltip[j] = "Gzipped";
                    txt[j] = "g";
                    j++;
                }

                if (data[5] == true)
                {
                    tooltip[j] = "Packed";
                    txt[j] = "p";
                    j++;
                }

                if (data[6] == true)
                {
                    tooltip[j] = "Minified";
                    txt[j] = "m";
                    j++;
                }

                if (data[2] == true || data[3] == true || data[5] == true || data[6] == true)
                {
                    tooltip = '[' + tooltip.join('/') + '] ';
                    txt = '[' + txt.join('') + '] ';
                }

                attrs = ['menuitem',
                    ['label', txt + filename + data[0]],
                    ['oncommand', 'phoenix_viewSource("' + js[i] + '", "js", "' + where + '");'],
                    ['id', 'js-id-' + i],
                    ['tooltiptext', tooltip + js[i]],
                    ['class', 'menuitem-iconic' + italics],
                    ['image', 'chrome://phoenix/skin/images/javascript.png']];
                menu.appendChild(phoenix_makeElement(attrs));
            }

            if (type == 'all')
            {
                var label = phoenix_getStr('phoenix.javascriptFiles') + ' (' + js.length + ')' + ((phoenix_isInt(total_js_size) && total_js_size > 0) ? ' ~' + phoenix_formatSize(total_js_size) : '');
                document.getElementById('js-id-' + origin).setAttribute('label', label);
            }
        }

        if (js.length > 0 && css.length > 0 && type == 'all')
        {
            menu.appendChild(phoenix_makeElement(['menuseparator']));
        }

        if (css.length > 0 && (type == 'all' || type == 'css'))
        {
            var total_css_size = 0;
            if ((type == 'all' || type == 'css') && phoenix_prefs.getBoolPref('multipleInstances') == true)
            {
                attrs = ['menuitem',
                    ['id', 'css-id-' + origin],
                    ['oncommand', 'phoenix_viewAll("css", "' + where + '");'],
                    ['style','font-weight:bold'],
                    ['tooltiptext', phoenix_getStr('phoenix.openAllCSS')]];
                menu.appendChild(phoenix_makeElement(attrs));
            }

            else if ((type == 'all' || type == 'css') && origin != 'editor')
            {
                attrs = ['menuitem',
                    ['id', 'css-id-' + origin],
                    ['style','font-weight:bold'],
                    ['tooltiptext', '']];
                menu.appendChild(phoenix_makeElement(attrs));
            }

            for (var i = 0; i < css.length; ++i)
            {
                var filename = ((css[i].charAt(0) == '@') ? '@' : '') + phoenix_getFileName(css[i]);
                css[i] = css[i].replace(/^\@/, '');
                var data = phoenix_getFileSize(null, cache, css[i], false, 'css');
                var italics = (css[i].match(/^chrome/) || css[i].match(/^resource/)) ? " italics" : "";
                var tooltip = new Array();
                var txt = new Array();
                var j = 0;

                if (phoenix_isInt(data[1]))
                    total_css_size += data[1] * 1;

                if (data[2] == true)
                {
                    tooltip[j] = "Cached";
                    txt[j] = "c";
                    j++;
                }

                if (data[3] == true)
                {
                    tooltip[j] = "Gzipped";
                    txt[j] = "g";
                    j++;
                }

                if (data[5] == true)
                {
                    tooltip[j] = "Packed";
                    txt[j] = "p";
                    j++;
                }

                if (data[6] == true)
                {
                    tooltip[j] = "Minified";
                    txt[j] = "m";
                    j++;
                }

                if (data[2] == true || data[3] == true || data[5] == true || data[6] == true)
                {
                    tooltip = '[' + tooltip.join('/') + '] ';
                    txt = '[' + txt.join('') + '] ';
                }

                attrs = ['menuitem',
                    ['label', txt + filename + data[0]],
                    ['oncommand', 'phoenix_viewSource("' + css[i] + '", "css", "' + where + '");'],
                    ['id', 'css-id-' + i],
                    ['tooltiptext', tooltip + css[i]],
                    ['class', 'menuitem-iconic' + italics],
                    ['image', 'chrome://phoenix/skin/images/css.png']];
                menu.appendChild(phoenix_makeElement(attrs));
            }

            if (type == 'all')
            {
                var label = phoenix_getStr('phoenix.cssStylesheets') + ' (' + css.length + ')' + ((phoenix_isInt(total_css_size) && total_css_size > 0) ? ' ~' + phoenix_formatSize(total_css_size) : '');
                document.getElementById('css-id-' + origin).setAttribute('label', label);
            }
        }

        if ((js.length > 0 || css.length > 0) && type == 'all')
        {
            menu.appendChild(phoenix_makeElement(['menuseparator']));
        }
    }

    if (type == 'all' || type == 'html')
    {
        if (type == 'all')
        {
            attrs = ['menuitem',
                ['label', 'HTML'],
                ['style','font-weight:bold'],
                ['tooltiptext', phoenix_getStr('phoenix.openPageInfo')],
                ['oncommand', 'phoenix_pageInfo();']];
            menu.appendChild(phoenix_makeElement(attrs));
        }

        // var size = phoenix_getFileSize (cache, window.content.document.location, false, false);
        // var size = unescape((new XMLSerializer()).serializeToString(window.content.document)).length;
        // + ' (' + phoenix_formatSize (size) + ')'
        attrs = ['menuitem',
            ['label', phoenix_getStr('phoenix.viewHTMLsource')],
            ['oncommand', 'phoenix_viewHTMLsource("html", "' + where + '");'],
            ['tooltiptext', 'View HTML source'],
            ['class', 'menuitem-iconic'],
            ['image', 'chrome://phoenix/skin/images/html.png']];
        menu.appendChild(phoenix_makeElement(attrs));

        attrs = ['menuitem',
            ['label', phoenix_getStr('phoenix.generatedSource')],
            ['oncommand', 'phoenix_viewHTMLsource("generated", "' + where + '");'],
            ['tooltiptext', 'View generated HTML source'],
            ['class', 'menuitem-iconic'],
            ['image', 'chrome://phoenix/skin/images/html.png']];
        menu.appendChild(phoenix_makeElement(attrs));
    }

    // we need this try as "window.content" is not always defined for top menu in editor
    try {
        var phoenix_url = window.content.document.domain.replace(/www\./, '');
        var urlsall = phoenix_prefs.getCharPref('allowedtextall');
        var urlsnone = phoenix_prefs.getCharPref('allowedtextnone');

        if (phoenix_url != '' && phoenix_url != null) // && origin == 'editor'
        {
			if (urlsall.indexOf(phoenix_url) >= 0 && phoenix_prefs.getIntPref('allowedUrls') == "0")
			{
				menu.appendChild(phoenix_makeElement(['menuseparator']));
				attrs = ['menuitem',
					['label', phoenix_getStr('phoenix.remove') + ' \'' + phoenix_url + '\' ' + phoenix_getStr('phoenix.fromListInactive')],
					['oncommand', 'phoenix_add_to_url_list("remove", "' + phoenix_url + '");'],
					['tooltiptext', phoenix_getStr('phoenix.remove') + ' \'' + phoenix_url + '\' ' + phoenix_getStr('phoenix.fromListInactive')]];
				menu.appendChild(phoenix_makeElement(attrs));
			}

			else if (urlsnone.indexOf(phoenix_url) >= 0 && phoenix_prefs.getIntPref('allowedUrls') == "1")
			{
				menu.appendChild(phoenix_makeElement(['menuseparator']));
				attrs = ['menuitem',
					['label', phoenix_getStr('phoenix.remove') + ' \'' + phoenix_url + '\' ' + phoenix_getStr('phoenix.fromListActive')],
					['oncommand', 'phoenix_add_to_url_list("remove", "' + phoenix_url + '");'],
					['tooltiptext', phoenix_getStr('phoenix.remove') + ' \'' + phoenix_url + '\' ' + phoenix_getStr('phoenix.fromListActive')]];
				menu.appendChild(phoenix_makeElement(attrs));
			}

			else if (phoenix_url.indexOf(urlsall) == -1 && phoenix_prefs.getIntPref('allowedUrls') == "0") //(phoenix_this_url_allowed == false)
			{
				menu.appendChild(phoenix_makeElement(['menuseparator']));
				attrs = ['menuitem',
					['label', phoenix_getStr('phoenix.add') + ' \'' + phoenix_url + '\' ' + phoenix_getStr('phoenix.toListInactive')],
					['oncommand', 'phoenix_add_to_url_list("add", "' + phoenix_url + '");'],
					['tooltiptext', phoenix_getStr('phoenix.add') + ' ' + phoenix_url + ' ' + phoenix_getStr('phoenix.toListInactive')]];
				menu.appendChild(phoenix_makeElement(attrs));
			}

			else if (phoenix_url.indexOf(urlsnone) == -1 && phoenix_prefs.getIntPref('allowedUrls') == "1") //(phoenix_this_url_allowed == false)
			{
				menu.appendChild(phoenix_makeElement(['menuseparator']));
				attrs = ['menuitem',
					['label', phoenix_getStr('phoenix.add') + ' \'' + phoenix_url + '\' ' + phoenix_getStr('phoenix.toListActive')],
					['oncommand', 'phoenix_add_to_url_list("add", "' + phoenix_url + '");'],
					['tooltiptext', phoenix_getStr('phoenix.add') + ' ' + phoenix_url + ' ' + phoenix_getStr('phoenix.toListActive')]];
				menu.appendChild(phoenix_makeElement(attrs));
			}
        }
    }
    catch (e) {}
}


function phoenix_makeElement(attrs) {
    var elem = document.createElement(attrs[0]);
    for (var i = 1; i < attrs.length; ++i)
        elem.setAttribute(attrs[i][0], attrs[i][1]);

    return (elem);
}

function phoenix_getJS(wins)
{
    var scriptUrls = [];
    var scripts, loc, source, srcAttr, uri;

    for (var i = 0; i < wins.length; ++i)
    {
        scripts = wins[i].document.getElementsByTagName('script');
        for (var j = 0; j < scripts.length; ++j)
        {
            if (scripts[j].hasAttribute('src'))
            {
                srcAttr = scripts[j].getAttribute('src');
                source = (srcAttr.substr(0, 9) == 'chrome://') ? srcAttr : scripts[j].src;
                if (source)
                {
                    //we need to make sure all anchors are removed from the urls
                    scriptUrls.push(source.replace(/#.*$/, ''));
                }
            }
        }
    }

    return (scriptUrls);
}


function phoenix_getCSS(wins)
{
    var sheets, loc, uri;
    var styleUrls = [];

    for (var i = 0; i < wins.length; ++i)
    {
        sheets = wins[i].document.styleSheets;
        for (var j = 0; j < sheets.length; ++j)
        {
            if (sheets[j].href) //sheets[j].rel.toLowerCase().indexOf('stylesheet') >= 0 &&
                styleUrls.push(sheets[j].href.replace(/#.*$/, ''));

            styleUrls = styleUrls.concat(phoenix_getImportedCSS(sheets[j]));
        }
    }

    return (styleUrls);
}

function phoenix_getImportedCSS(css) {
    var urls = [];
    var sheets = [css];

    for (var i = 0; i < sheets.length; ++i)
    {
        try { // fro the cases where there's no imported sheets
            for (var j = 0; j < sheets[i].cssRules.length; ++j)
            {
                if (sheets[i].cssRules[j].type != 3)
                    break;

                if (sheets[i].cssRules[j].styleSheet && sheets[i].cssRules[j].styleSheet.href)
                {
                    //we need to make sure all anchors are removed from the urls
                    //we also add @ to mark imported sheets
                    urls.push('@' + sheets[i].cssRules[j].styleSheet.href.replace(/#.*$/, ''));
                    sheets.push(sheets[i].cssRules[j].styleSheet);
                }
            }
        }
        catch (e) {
        }

        //we break after reaching 50 to avoid a possible endless loop from
        //occurring if a stylesheet tries to import itself over and over...
        if (i >= 50)
            break;
    }
    return (urls);
}

function phoenix_viewAll(type, where) {
    //get a reference to all dom windows in current page
    var wins = phoenix_getFrames();
    var urls = (type == 'js') ? phoenix_getJS(wins) : phoenix_getCSS(wins);
    for (var i = 0; i < urls.length; ++i)
    {
        urls[i] = urls[i].replace(/^\@/, '');
        setTimeout("phoenix_viewSource('" + urls[i] + "', '" + type + "', '" + where + "')", i * 500);
    }
}


function phoenix_getFileName(file)
{
    if (file.indexOf('?'))
    {
        var parts = file.split('?');
        var filename = parts[0];
    }
    else
    {
        var filename = file;
    }

    filename = filename.replace(/#.*$/, '');
    filename = filename.substring(filename.lastIndexOf('/') + 1);

    return (filename);
}


function phoenix_getFrames()
{
    try {
        var frms = [window.opener.content];
    }
    catch(e) {
        var frms = [window.content];
    }

    for (var i = 0; i < frms.length; ++i)
    {
        for (var j = 0; j < frms[i].frames.length; ++j)
        {
            frms.push(frms[i].frames[j]);
        }
        //we break after reaching 50 to avoid a possible endless loop from
        //occurring if the website has coded frames within frames.........
        if (i >= 50)
            break;
    }

    return (frms);
}


function phoenix_getCacheService() {
    return (Components.classes["@mozilla.org/network/cache-service;1"].getService(Components.interfaces.nsICacheService).createSession("HTTP", 0, true));
}

function phoenix_getFileSizeAsync(files, counter, cache, prepare, type) {
//    consoleService.logStringMessage("-> files.length <- " + files.length);

    if (files.length > 0) {
        var file = files[files.length-1];

        if (!Application.storage.has(phoenix_md5('size' + file))) {
            phoenix_fileInfoAsync(files, counter, cache, prepare, type);
        } else {
            files.pop();
            counter.numOfCheckedScripts++;
//            consoleService.logStringMessage("-> Cached <- file: " + file);
//            consoleService.logStringMessage("Cached @@@$$$$$$$$$$$$$$$ counter.numOfCheckedScripts: " + counter.numOfCheckedScripts);

            phoenix_getFileSizeAsync(files, counter, cache, prepare, type);
        }
    }
}

function getMillis(data) {
    return data.getSeconds() * 1000 + data.getMilliseconds();
}

// http://www.jibbering.com/2002/4/httprequest.html
// https://developer.mozilla.org/En/Using_XMLHttpRequest
// http://www.jibbering.com/2002/4/httprequest.html
function phoenix_fileInfoAsync(files, counter, cache, prepare, type) {
    var url = files.pop();

//    consoleService.logStringMessage("-> NOT Cached <- file: " + url);
    var shouldEvalMinified = phoenix_shouldEvalMinified();

    var xmlhttp = new XMLHttpRequest();
    xmlhttp.onreadystatechange = function() {
        var simple = 0;
        var cached = false;
        var gzipped = false;
        var size = 0;
        var headers = '';

        if (this.readyState == 4) {
            clearTimeout(xmlHttpTimeout);

//            consoleService.logStringMessage("XHR: " + this.url);

            if (this.status == "304") {
                cached = true;
            }

            if (this.getResponseHeader('Content-Encoding') == 'gzip') {
                gzipped = true;
            }

            // http://phpjs.org/functions/view/401
            var contentLength = this.getResponseHeader('Content-Length');
            if (contentLength) {
                size = contentLength;
            }

            headers = this.getAllResponseHeaders();

            try {
                entry = cache.openCacheEntry(url, Components.interfaces.nsICache.ACCESS_READ, false);
                simple = entry.dataSize;
                size = ' (' + phoenix_formatSize(simple) + ')';
                Application.storage.set(phoenix_md5('size' + url), simple);
                cached = true;
            } catch(e) {
                if (prepare) {
                    if (phoenix_isInt(simple)) {
                        size = ' (' + phoenix_formatSize(simple) + ')';
                        Application.storage.set(phoenix_md5('size' + url), simple);
                    }
                } else {
                    Application.storage.set(phoenix_md5('size' + url), false);
                }
            }

            Application.storage.set(phoenix_md5('cache' + url), cached);
            Application.storage.set(phoenix_md5('gzip' + url), gzipped);
            Application.storage.set(phoenix_md5('headers' + url), headers);

            counter.numOfCheckedScripts++;
//            consoleService.logStringMessage("Not Cached @@@$$$$$$$$$$$$$$$ counter.numOfCheckedScripts: " + counter.numOfCheckedScripts);

            if (this.shouldEvalMinified) {
                var xmlhttp2 = new XMLHttpRequest();
                xmlhttp2.onreadystatechange = function() {
                    var packed = false;
                    var minified = false;

                    var code = this.responseText;
                    Application.storage.set(phoenix_md5('file' + url), code);

                    if (type == 'js') {
                        packed = phoenix_isPacked(code);
                    }

                    if (!packed) {
                        minified = phoenix_isMinified(code);
                    }

                    Application.storage.set(phoenix_md5('packed' + url), packed);
                    Application.storage.set(phoenix_md5('minified' + url), minified);

//                    consoleService.logStringMessage("2 Invoking: phoenix_getFileSizeAsync");
                    phoenix_getFileSizeAsync(files, counter, cache, prepare, type);
                };

                xmlhttp2.open('GET', url, true);
                xmlhttp2.send(null);
            } else {
//                consoleService.logStringMessage("1 Invoking: phoenix_getFileSizeAsync");
                phoenix_getFileSizeAsync(files, counter, cache, prepare, type);
            }
        }
    };

    xmlhttp.url = url;
    xmlhttp.shouldEvalMinified = shouldEvalMinified;
    xmlhttp.open('HEAD', url, true);
    xmlhttp.send(null);

// Timeout to abort in 1 second
    var xmlHttpTimeout = setTimeout(function (){
       xmlhttp.abort();

//        consoleService.logStringMessage("REQUEST ABORTED");
        Application.storage.set(phoenix_md5('size' + url), '');

        counter.numOfCheckedScripts++;
//        consoleService.logStringMessage("Not Cached @@@$$$$$$$$$$$$$$$ counter.numOfCheckedScripts: " + counter.numOfCheckedScripts);

//        consoleService.logStringMessage("3 Invoking: phoenix_getFileSizeAsync");
        phoenix_getFileSizeAsync(files, counter, cache, prepare, type);
    }, 5000);

    //    http://sourceforge.net/projects/tmp3/files/working%20alpha/0.02%20-%20With%20nice%20GUI%20_%29/tmp3.zip/download
    //    if (xmlhttp.getResponseHeader('Content-Type')) {
    //        consoleService.logStringMessage("-> GFS <- Content-Type: " + xmlhttp.getResponseHeader('Content-Type'));
    //    }


//    if (shouldEvalMinified) {
//
//    }
}

function phoenix_getFileSize(counter, cache, file, prepare, type)
{
    var simple = 0;
    var size = '';
    var cached = false;
    var gzipped = false;
    var headers = '';
    var packed = false;
    var minified = false;

//    consoleService.logStringMessage("Cached: " + Application.storage.has(phoenix_md5('size' + file)) + " URL: " + file);

    if (Application.storage.has(phoenix_md5('size' + file)))
    {
        simple = Application.storage.get(phoenix_md5('size' + file), false);
        cached = Application.storage.get(phoenix_md5('cache' + file), false);
        gzipped = Application.storage.get(phoenix_md5('gzip' + file), false);
        headers = Application.storage.get(phoenix_md5('headers' + file), false);
        packed = Application.storage.get(phoenix_md5('packed' + file), false);
        minified = Application.storage.get(phoenix_md5('minified' + file), false);
        size = ' (' + phoenix_formatSize(simple) + ')';

    } else {
        data = phoenix_fileInfo(file, type);
        cached = data[0];
        gzipped = data[1];
        simple = data[2];
        headers = data[3];
        packed = data[4];
        minified = data[5];

        try {
            entry = cache.openCacheEntry(file, Components.interfaces.nsICache.ACCESS_READ, false);
            simple = entry.dataSize;
            size = ' (' + phoenix_formatSize(simple) + ')';
            Application.storage.set(phoenix_md5('size' + file), simple);
            cached = true;
        }
        catch(e) {
            if (prepare) {
                if (phoenix_isInt(simple)) {
                    size = ' (' + phoenix_formatSize(simple) + ')';
                    Application.storage.set(phoenix_md5('size' + file), simple);
                }
            } else {
                Application.storage.set(phoenix_md5('size' + file), false);
            }
        }

        Application.storage.set(phoenix_md5('cache' + file), cached);
        Application.storage.set(phoenix_md5('gzip' + file), gzipped);
        Application.storage.set(phoenix_md5('headers' + file), headers);
        Application.storage.set(phoenix_md5('packed' + file), packed);
        Application.storage.set(phoenix_md5('minified' + file), minified);
    }

    if (size.match(/undefined/)) {
        size = '';
    }

    if (counter != null) {
        counter.numOfCheckedScripts++;
    }

    return (new Array(size, simple, cached, gzipped, headers, packed, minified));
}


// http://www.jibbering.com/2002/4/httprequest.html
// https://developer.mozilla.org/En/Using_XMLHttpRequest
// http://www.jibbering.com/2002/4/httprequest.html
function phoenix_fileInfo(url, type) {
    var cached = false;
    var gzipped = false;
    var size = 0;
    var headers = '';
    var packed = false;
    var minified = false;

    var xmlhttp = new XMLHttpRequest();
    xmlhttp.open('HEAD', url, false);
    xmlhttp.send(null);

    if (xmlhttp.status == "304")
        cached = true;

    if (xmlhttp.getResponseHeader('Content-Encoding') == 'gzip')
        gzipped = true;

    // http://phpjs.org/functions/view/401
    if (xmlhttp.getResponseHeader('Content-Length'))
        size = xmlhttp.getResponseHeader('Content-Length');

    headers = xmlhttp.getAllResponseHeaders();

    if (phoenix_shouldEvalMinified()) {
        var xmlhttp = new XMLHttpRequest();
        xmlhttp.open('GET', url, false);
        xmlhttp.send(null);

        var code = xmlhttp.responseText;
        Application.storage.set(phoenix_md5('file' + url), code);

        if (type == 'js') {
            packed = phoenix_isPacked(code);
        }

        if (!packed) {
            minified = phoenix_isMinified(code);
        }
    }

    return (new Array(cached, gzipped, size, headers, packed, minified));
}

function phoenix_shouldEvalMinified() {
    return phoenix_prefs.getBoolPref('checkPackedMinified') &&
           (phoenix_prefs.getCharPref('checkPackedMinifiedMax') * 1 == 0 ||
            phoenix_prefs.getCharPref('checkPackedMinifiedMax') * 1 > phoenix_total_files
                   );
}

function phoenix_isPacked(code) {
    var pattern = /eval\(function\(p,a,c,k.*?,0,\{\}\)\)/mi;

    return code.match(pattern) != null;
}

function phoenix_isMinified(code) {
    var spaces = code.split(/ /g).length - 1;
    var lines = code.split(/\n/g).length - 1;
    var length = code.length;

    return length / lines > 200 || length / spaces > 50;
}

function phoenix_formatSize(bytes)
{
    var s = ['bytes', 'KB', 'MB', 'GB', 'TB', 'PB'];
    var e = Math.floor(Math.log(bytes * 1) / Math.log(1024));

    if (s[e] == 'bytes')
        return ((bytes * 0.0009765625).toFixed(2) + " " + s[1]);

    else
        return (((bytes * 1) / Math.pow(1024, Math.floor(e))).toFixed(2) + " " + s[e]);
}


function phoenix_viewHTMLsource(type, where)
{
    if (where == 'new')
    {
        if (phoenix_prefs.getIntPref('openhtmlin') == 0 && type == 'html')
        {
            var url = "view-source:" + window.content.document.location;
            getBrowser().addTab(url);
        }

        else if (phoenix_prefs.getIntPref('openhtmlin') == 1 && type == 'html')
        {
            var url = "view-source:" + window.content.document.location;
            var newTab = getBrowser().addTab(url);
            getBrowser().selectedTab = newTab;
        }

        // Phoenix Editor
        else if (phoenix_prefs.getIntPref('openhtmlin') == 2)
            {
                var url = window.content.document.location;
                if (type == 'html')
                    phoenix_openEditorWindow(url, 'html', unescape((new XMLSerializer()).serializeToString(window.content.document)));

                if (type == 'generated')
                    phoenix_openEditorWindow(url, 'html', window.content.document.documentElement.innerHTML);
            }

            else if (phoenix_prefs.getIntPref('openhtmlin') == 3 && type == 'html')
                {
                    BrowserViewSourceOfDocument(window.content.document.location);
                }

                else if (type == 'generated')
                    {
                        var currentDocument = window.top.getBrowser().selectedBrowser.contentDocument;
                        var currentWindow = window.top.getBrowser().selectedBrowser.contentWindow;
                        var selection = currentWindow.getSelection();
                        selection.selectAllChildren(currentDocument.documentElement);

                        generatedSource = window.openDialog("chrome://global/content/viewPartialSource.xul", "_blank", "chrome,dialog=no,resizable,scrollbars", getBrowser().currentURI.spec, "charset=" + currentDocument.characterSet, currentWindow.getSelection(), "selection");
                        window.setTimeout(phoenix_clearGeneratedSourceSelection, 1500, selection, generatedSource);
                    }
    }

    if (where == 'current')
    {
        if (type == 'html')
            phoenix_importFile(window.opener.content.location);

        if (type == 'generated')
            phoenix_put_code(window.opener.content.document.documentElement.innerHTML);

        phoenix_setEditor('html');
        document.getElementById('url').value = window.opener.content.location;
    }
}


function phoenix_viewSource(url, type, where)
{
    // url: url of file
    // type: type of file ('css', 'html' or 'js')
    // where: open a new window or in current window ('new', 'current')

    if (phoenix_prefs.getIntPref('open' + type + 'in') == 0)
    {
        url = 'view-source:' + url;
        getBrowser().addTab(url);
    }

    else if (phoenix_prefs.getIntPref('open' + type + 'in') == 1)
    {
        url = 'view-source:' + url;
        var newTab = getBrowser().addTab(url);
        getBrowser().selectedTab = newTab;
    }

    // Phoenix Editor
    else if (phoenix_prefs.getIntPref('open' + type + 'in') == 2)
        {
            if (where == 'new')
            {
                phoenix_openEditorWindow(url, type);
            }

            else
            {
                phoenix_importFile(url);
                phoenix_setEditor(type);
                document.getElementById('url').value = url;
            }
        }

        // Mozilla view source
        else if (phoenix_prefs.getIntPref('open' + type + 'in') == 3)
            {
                var win = window.openDialog(url, "View source", "centerscreen=yes,dialog=no,resizable=yes,width=" + phoenix_prefs.getIntPref('width') + ", height=" + phoenix_prefs.getIntPref('height') + ",chrome=yes");
                win.focus();
            }
}


function phoenix_openEditorWindow(url, type, source)
{
    // https://developer.mozilla.org/En/DOM/Window.openDialog
    // the Math.random() allows multiple instances of the editor to exist
    var multiple = (phoenix_prefs.getBoolPref('multipleInstances') == true) ? Math.random() : '';
    var win = window.openDialog("chrome://phoenix/content/editor.xul", "phoenixEditor" + multiple, "centerscreen=yes,dialog=no,resizable=yes,width=" + phoenix_prefs.getCharPref('width') + ", height=" + phoenix_prefs.getCharPref('height') + ",chrome=yes", url, type, source);
    win.focus();
}


function phoenix_clearGeneratedSourceSelection(selection, generatedSource)
{
    selection.removeAllRanges();
    generatedSource.getBrowser().contentWindow.getSelection().removeAllRanges();
}


function phoenix_showOptions(ev, menu)
{
    // not sure why, but somehow the editor's options button registers 0
    // for a left click event instead of the usual 1. right click events are 3
    if (ev.which > 1)
    {
        ev.preventDefault();

        if (menu)
            menu.hidePopup();

        window.openDialog("chrome://phoenix/content/options.xul", phoenix_getStr('phoenix.options'), "centerscreen,chrome,modal,resizable");
    }
    else if (ev.which == 0)
    {
        window.openDialog("chrome://phoenix/content/options.xul", phoenix_getStr('phoenix.options'), "centerscreen,chrome,modal,resizable");
    }
}


function phoenix_setEditor(type)
{
    if (type == 'css')
    {
        document.getElementById("icon-type").src = "chrome://phoenix/skin/images/css.png";
        document.getElementById("execute-button").setAttribute('label', phoenix_getStr('phoenix.executeCSS'));
        document.getElementById("execute-button").setAttribute('tooltiptext', phoenix_getStr('phoenix.executeCSStooltip'));
        window.document.getElementById('phoenixMinify').setAttribute('disabled', 'false');
        window.document.getElementById('phoenixPack').setAttribute('disabled', 'true');
    }

    if (type == 'html')
    {
        document.getElementById("icon-type").src = "chrome://phoenix/skin/images/html.png";
        document.getElementById("execute-button").setAttribute('label', phoenix_getStr('phoenix.executeHTML'));
        document.getElementById("execute-button").setAttribute('tooltiptext', phoenix_getStr('phoenix.executeHTMLtooltip'));
        window.document.getElementById('phoenixMinify').setAttribute('disabled', 'true');
        window.document.getElementById('phoenixPack').setAttribute('disabled', 'true');
    }

    if (type == 'js')
    {
        document.getElementById("icon-type").src = "chrome://phoenix/skin/images/javascript.png";
        document.getElementById("execute-button").setAttribute('label', phoenix_getStr('phoenix.executeJS'));
        document.getElementById("execute-button").setAttribute('tooltiptext', phoenix_getStr('phoenix.executeJStooltip'));
        window.document.getElementById('phoenixMinify').setAttribute('disabled', 'false');
        window.document.getElementById('phoenixPack').setAttribute('disabled', 'false');
    }

    var elems = document.getElementById('phoenixIFrame').contentWindow.document.getElementsByTagName('script');
    for (var i = 0; i < elems.length; i++)
    {
        if (elems[i].src.match(/css\.js/) || elems[i].src.match(/html\.js/) || elems[i].src.match(/js\.js/))
            elems[i].parentNode.removeChild(elems[i]);
    }

    var elems = document.getElementById('phoenixIFrame').contentWindow.document.getElementsByTagName('link');
    for (var i = 0; i < elems.length; i++)
    {
        if (elems[i].href.match(/css\.css/) || elems[i].href.match(/html\.css/) || elems[i].href.match(/js\.css/))
            elems[i].parentNode.removeChild(elems[i]);
    }

    // http://www.javascriptkit.com/javatutors/loadjavascriptcss.shtml
    var fileref = document.getElementById('phoenixIFrame').contentWindow.document.createElement('script');
    fileref.setAttribute("type", "text/javascript");
    fileref.setAttribute("src", "syntax/" + type + ".js");
    document.getElementById('phoenixIFrame').contentWindow.document.getElementsByTagName("head")[0].appendChild(fileref);

    var fileref = document.getElementById('phoenixIFrame').contentWindow.document.createElement("link");
    fileref.setAttribute("rel", "stylesheet");
    fileref.setAttribute("type", "text/css");
    fileref.setAttribute("href", "syntax/" + type + ".css");
    document.getElementById('phoenixIFrame').contentWindow.document.getElementsByTagName("head")[0].appendChild(fileref);

    if (phoenix_prefs.getBoolPref('syntaxHighlighting') == false && phoenix_prefs.getBoolPref('lineNumbers') == false)
    {
        var obj = document.getElementById('phoenixIFrame').contentWindow;
        obj.phoenix_CodePress.exit();
        var data = obj.document.body.innerHTML;
        data = data.replace(/<br[^>]?>/mig, "\n");
        obj.document.body.innerHTML = data.replace(/<[^>]*>/mig, '');
    }

    window.arguments[1] = type;
}


function phoenix_importFile(url)
{
    xmlhttp = new XMLHttpRequest();
    xmlhttp.open('GET', url, true);
    xmlhttp.onreadystatechange = function() {
        if (xmlhttp.readyState == 4) {
            Application.storage.set(phoenix_md5('file' + url), xmlhttp.responseText);
            phoenix_put_code(xmlhttp.responseText);
            phoenix_editorFocus();
        }
    };

    xmlhttp.send(null);
    void(0);
}


function phoenix_getPrefs()
{
    return Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("phoenix.");
}

function phoenix_setInitialPrefs()
{
    phoenix_prefs = phoenix_getPrefs();

    if (document.getElementById('bottom_console'))
    {
        if (phoenix_prefs.getBoolPref('openDocked') && phoenix_prefs.getBoolPref('showErrorConsole'))
        {
            document.getElementById('bottom_splitter').style.display = 'block';
            document.getElementById('bottom_console').style.display = 'block';
            document.getElementById('bottom_console').setAttribute('height', phoenix_prefs.getIntPref('ErrorConsoleHeight'));
        } else {
            document.getElementById('bottom_splitter').style.display = 'none';
            document.getElementById('bottom_console').style.display = 'none';
        }
    }

    if (document.getElementById('phoenix-context')) {
        if (phoenix_prefs.getBoolPref('showContext'))
            document.getElementById('phoenix-context').style.display = 'block';

        else
            document.getElementById('phoenix-context').style.display = 'none';
    }

    if (document.getElementById('phoenix-status')) {
        if (phoenix_prefs.getBoolPref('showStatus'))
            document.getElementById('phoenix-status').style.display = 'block';

        else
            document.getElementById('phoenix-status').style.display = 'none';
    }

    try {
        if (window.opener.document.getElementById('phoenixIFrame'))
        {
            window.opener.innerWidth = phoenix_prefs.getIntPref('width');
            window.opener.innerHeight = phoenix_prefs.getIntPref('height');
            window.opener.document.getElementById('url').style.width = (phoenix_prefs.getIntPref('width') - phoenix_urlbar_adjust) + "px";

            var obj = window.opener.document.getElementById('phoenixIFrame').contentWindow.document.body;
            phoenix_line_numbers_set(obj);
        }
    }
    catch(e) {
    }

    if (phoenix_prefs.getBoolPref('syntaxHighlighting') || phoenix_prefs.getBoolPref('lineNumbers')) {
        phoenix_syntax_start();
    } else {
        phoenix_syntax_stop();
    }
}


function phoenix_escapeHTML(str)
{
    var code = str.replace(/&/g, '&amp;').replace(/>/g, '&gt;').replace(/</g, '&lt;').replace(/"/g, '&quot;');

    return (code);
}


function phoenix_unescapeHTML(str)
{
    return (str.replace(/\&amp;/g, '&').replace(/\&gt;/g, '>').replace(/\&lt;/g, '<').replace(/\&quot;/g, '"'));
}


function phoenix_saveSize()
{
    phoenix_prefs = phoenix_getPrefs();

    phoenix_prefs.setCharPref('width', window.innerWidth);
    phoenix_prefs.setCharPref('height', window.innerHeight);

    document.getElementById('url').style.width = (window.innerWidth - phoenix_urlbar_adjust) + "px";

    phoenix_prefs = phoenix_getPrefs();
}


function phoenix_saveConsoleSize()
{
    var h = document.getElementById('bottom_console').getAttribute('height');
    if (phoenix_prefs)
        phoenix_prefs.setIntPref('ErrorConsoleHeight', h);
}


function phoenix_pageInfo()
{
    var appInfo = Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULAppInfo);
    var versionChecker = Components.classes["@mozilla.org/xpcom/version-comparator;1"].getService(Components.interfaces.nsIVersionComparator);
    if (versionChecker.compare(appInfo.version, "3.0b3") >= 0)
    {
        // Firefox 3.0 beta3 or later
        window.openDialog('chrome://browser/content/pageinfo/pageInfo.xul');
    }
    else
    {
        // a previous Firefox version
        window.openDialog('chrome://browser/content/pageInfo.xul');
    }
}


function phoenix_isInt(i)
{
    return ((i % 1) == 0);
}


function phoenix_syntax_start()
{
    try {
        var obj = window.opener.document.getElementById('phoenixIFrame').contentWindow;
        obj.document.body.innerHTML = obj.document.body.innerHTML.replace(/\n/mig, "<br>");
        obj.phoenix_CodePress.initialize();
        obj.phoenix_CodePress.syntaxHighlight('generic');
    }
    catch(e) {
    }
}


function phoenix_syntax_stop()
{
    try {
        var obj = window.opener.document.getElementById('phoenixIFrame').contentWindow;
        obj.phoenix_CodePress.exit();
        var data = obj.document.body.innerHTML;
        data = data.replace(/<br[^>]?>/mig, "\n");
        data = data.replace(/<[^>]*>/mig, '');

        if (phoenix_prefs.getBoolPref('lineNumbers'))
            data = phoenix_line_numbers(data);

        obj.document.body.innerHTML = data;
    }
    catch(e) {
    }
}


function phoenix_line_numbers(code)
{
    code = code.replace(/\n/gm, "<li><a>");
    code = "<ol><li><a>" + code + "</ol>";

    return (code);
}


function phoenix_line_numbers_set(obj)
{
    if (phoenix_prefs.getBoolPref('lineNumbers') == true)
    {
        obj.style.marginLeft = "50px";
        obj.style.backgroundImage = "url('chrome://phoenix/skin/images/gutter.png')";
    }

    if (phoenix_prefs.getBoolPref('lineNumbers') == false)
    {
        obj.style.marginLeft = "0px";
        obj.style.backgroundImage = "none";
    }
}


function phoenix_get_code()
{
    var code = document.getElementById('phoenixIFrame').contentWindow.document.body.innerHTML.replace(/^\s+/, '');
    code = code.replace(/<br[^>]*>/mig, "\n");
    code = code.replace(/<\/li>/mig, "\n");
    code = code.replace(/<[^>]*>/mig, '');
    code = phoenix_unescapeHTML(code);

    return (code);
}


function phoenix_put_code(code)
{
    code = phoenix_escapeHTML(code);
    document.getElementById('phoenixIFrame').contentWindow.document.body.innerHTML = code;
}


// http://www.dustindiaz.com/top-ten-javascript/
function phoenix_getElementsByClass(searchClass, node, tag)
{
    var classElements = new Array();
    if (node == null)
        node = document;

    if (tag == null)
        tag = '*';

    var els = node.getElementsByTagName(tag);
    var elsLen = els.length;
    var pattern = new RegExp('(^|\\\\s)' + searchClass + '(\\\\s|$)');

    for (i = 0,j = 0; i < elsLen; i++)
    {
        if (pattern.test(els[i].className))
        {
            classElements[j] = els[i];
            j++;
        }
    }

    return (classElements);
}


function phoenix_trim(str)
{
    var whitespace = ' \n\r\t\f\x0b\xa0\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200a\u200b\u2028\u2029\u3000';
    for (var i = 0; i < str.length; i++)
    {
        if (whitespace.indexOf(str.charAt(i)) === -1)
        {
            str = str.substring(i);
            break;
        }
    }
    for (i = str.length - 1; i >= 0; i--)
    {
        if (whitespace.indexOf(str.charAt(i)) === -1)
        {
            str = str.substring(0, i + 1);
            break;
        }
    }
    return whitespace.indexOf(str.charAt(0)) === -1 ? str : '';
}


function phoenix_getStr(name)
{
    return document.getElementById("phoenix-bundle").getString(name);
}


/*
 * Debug
 * use "phoenix_inspect (obj);"
 */
function phoenix_inspect(obj, maxLevels, level)
{
    var str = '', type, msg;

    // Start Input Validations: don't touch, we start iterating at level zero
    if (level == null)
        level = 0;

    // At least you want to show the first level
    if (maxLevels == null)
        maxLevels = 1;

    if (maxLevels < 1)
        return ('Error: Levels number must be > 0');

    // We start with a non null object
    if (obj == null)
        return ('Error: Object NULL');

    // Start iterations for all objects in obj
    for (property in obj)
    {
        try {
            // Show "property" and "type property"
            type = typeof(obj[property]);
            str += '(' + type + ') ' + property + ((obj[property] == null) ? (': null') : ('')) + "\n";

            // We keep iterating if this property is an Object, non null and we are inside the required number of levels
            if ((type == 'object') && (obj[property] != null) && (level + 1 < maxLevels))
                str += phoenix_inspect(obj[property], maxLevels, level + 1);
        }
        catch(e)
        {
            // Is there some properties in obj we can't access? Print it red.
            if (typeof(e) == 'string') msg = e;
            else if (e.message)        msg = e.message;
            else if (e.description)    msg = e.description;
                else                       msg = 'Unknown';

            str += '(Error) ' + property + ': ' + msg + "\n";
        }
    }

    alert(str);
}

function phoenix_get_source(what)
{
    if (what == 'html')
    {
        var code = document.getElementById('phoenixIFrame').contentWindow.document.body.innerHTML;
        code = code.replace(/<\/li>/mg, '</li>\n');
        code = code.replace(/<br>/mg, '<br>\n');
        code = code.replace(/<ol>/mg, '<ol>\n');
    }

    else
    {
        var code = phoenix_get_code();
    }

    alert(code);
}