phoenix_consoleservice = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);

phoenix_content = null;

function phoenix_load(e) {

    if (e) {
        if (e.originalTarget instanceof HTMLDocument &&
            e.originalTarget.defaultView &&
            e.originalTarget.defaultView.frameElement) {

            var doc = e.originalTarget;

            // Frame within a tab was loaded. doc should be the root document of
            // the frameset. If you don't want do anything when frames/iframes
            // are loaded in this web page, uncomment the following line:
            // return;
            // Find the root document:
            while (doc.defaultView.frameElement) {
                doc = doc.defaultView.frameElement.ownerDocument;
            }

            if (doc instanceof HTMLDocument) {
                //                phoenix_consoleservice.logStringMessage("PHOENIX_LOAD doc: " + doc);
                //                phoenix_consoleservice.logStringMessage("PHOENIX_LOAD doc.infoCollected: " + doc.infoCollected);

                //                if (!doc.infoCollected) {
                //                    doc.infoCollected = true;

                phoenix_setInitialPrefs();
                phoenix_test_allowed();
                //                }
            }
        }
    } else {
        //        phoenix_consoleservice.logStringMessage("PHOENIX_LOAD: null");
        phoenix_setInitialPrefs();
        phoenix_test_allowed();
    }
}

phoenix_url2gzippedJSInfo = [];

phoenix_url2files = [];

function phoenix_getMillis(data) {
    return data.getSeconds() * 1000 + data.getMilliseconds();
}


function phoenix_toggleURL ()
{
   //alert('1');
   // we need this try as "window.content" is not always defined for top menu in editor
   // try {
        var phoenix_url = window.content.document.domain.replace(/www\./, '');
        var urlsall = phoenix_prefs.getCharPref('allowedtextall');
        var urlsnone = phoenix_prefs.getCharPref('allowedtextnone');

        if (phoenix_url != '' && phoenix_url != null) // && origin == 'editor'
        {
			if (urlsall.indexOf(phoenix_url) >= 0 && phoenix_prefs.getIntPref('allowedUrls') == "0")
				phoenix_add_to_url_list("remove", phoenix_url);

			else if (urlsnone.indexOf(phoenix_url) >= 0 && phoenix_prefs.getIntPref('allowedUrls') == "1")
				phoenix_add_to_url_list("remove", phoenix_url);

			else if (phoenix_url.indexOf(urlsall) == -1 && phoenix_prefs.getIntPref('allowedUrls') == "0")
				phoenix_add_to_url_list("add", phoenix_url);

			else if (phoenix_url.indexOf(urlsnone) == -1 && phoenix_prefs.getIntPref('allowedUrls') == "1")
				phoenix_add_to_url_list("add", phoenix_url);
        }
    //}
    //catch (e) {}
}



function phoenix_main() {
    var wins = phoenix_getFrames();

    if (document.getElementById('phoenix-status'))
        document.getElementById('phoenix-status').image = "chrome://phoenix/skin/images/loading.png";

    //    phoenix_consoleservice.logStringMessage("@@@ wins.length: " + wins.length);
    //    phoenix_consoleservice.logStringMessage("@@@ wins[0]: " + wins[0]);

    var js = phoenix_getJS(wins);
    var css = phoenix_getCSS(wins);

    var url = window.content.document.location;

    phoenix_url2files[url] = {js : js, css : css};


    if (phoenix_shouldEvalMinified()) {
        var gzippedJs = phoenix_url2gzippedJSInfo[url];

        if (gzippedJs != null) {
            //phoenix_consoleservice.logStringMessage("@@@ gzippedJs.length: " + gzippedJs.length);

            for each (var jsListener in gzippedJs) {
                phoenix_putDataInCache(jsListener.receivedData);
            }

            phoenix_url2gzippedJSInfo[url] = null;
            delete phoenix_url2gzippedJSInfo[url];
        }
    }

    //    phoenix_consoleservice.logStringMessage("@@@ js.length: " + js.length);
    //    phoenix_consoleservice.logStringMessage("@@@ css.length: " + css.length);

    if (document.getElementById('phoenix-context')) {
        var label = phoenix_getStr('phoenix.Phoenix') + " " + phoenix_getStr('phoenix.js') + " (" + js.length + ") " + phoenix_getStr('phoenix.css') + " (" + css.length + ")";
        document.getElementById('phoenix-context').setAttribute('label', label);
    }


    if (document.getElementById('phoenix-status')) {
        var label = phoenix_getStr('phoenix.js') + " (" + js.length + ") " + phoenix_getStr('phoenix.css') + " (" + css.length + ")";
        document.getElementById('phoenix-status-label').setAttribute('value', label);
    }

    //    phoenix_consoleservice.logStringMessage("%%%%% js.length: " + js.length);

    phoenix_getStat();
}

function phoenix_wait(condition, delay, callback) {

    if (condition()) {
        callback();
        return;
    }

    function handler() {
        if (condition()) {
            callback();
            return;
        }

        setTimeout(handler, delay);
    }

    setTimeout(handler, delay);
}

function phoenix_array_clone(arr) {
    var arr1 = new Array();
    for (var property in arr) {
        arr1[property] = typeof (arr[property]) == 'object' ? arr[property].clone() : arr[property];
    }
    return arr1;
}

function phoenix_getStat() {
    var url = window.content.document.location;
    //    phoenix_consoleservice.logStringMessage("%%%%% url: " + url);

    var cache = phoenix_cache;

    var js = phoenix_url2files[url].js;
    var css = phoenix_url2files[url].css;

    var counter = new Object();
    counter.numOfCheckedScripts = 0;

    var externalScriptsLength = js.length + css.length;
    //    phoenix_consoleservice.logStringMessage("@@@$$$ js.length[" + js.length + "] + css.length[" + css.length + "]: " + externalScriptsLength);

    phoenix_wait(
            function() {
                //                phoenix_consoleservice.logStringMessage("@@@$$$ counter.numOfCheckedScripts: " + counter.numOfCheckedScripts);

                return counter.numOfCheckedScripts == externalScriptsLength;
            },
            1000,
            function() {
                var total_js_size = 0;
                var total_css_size = 0;
                var cached = 0;
                var gzipped = 0;

                //                phoenix_consoleservice.logStringMessage("!!!CALLBACK!!!");
                ////////////////////////////////////////
                //  Update statistics here
                ///////////////////////////////////////

                if (document.getElementById('phoenix-status')) {
                    document.getElementById('phoenix-status').image = "chrome://phoenix/skin/images/icon.png";
                    document.getElementById('phoenix-tooltip-js').value = phoenix_getStr('phoenix.jsFiles') + " " + js.length + ((phoenix_isInt(total_js_size) && total_js_size > 0) ? ' (~' + phoenix_formatSize(total_js_size) + ")" : '');
                    document.getElementById('phoenix-tooltip-css').value = phoenix_getStr('phoenix.cssStylesheets') + " " + css.length + ((phoenix_isInt(total_css_size) && total_css_size > 0) ? ' (~' + phoenix_formatSize(total_css_size) + ")" : '');

                    for (var i = 0; i < js.length; ++i) {
                        var data = phoenix_getFileSize(counter, cache, js[i], true, 'js');

                        if (phoenix_isInt(data[1])) {
                            total_js_size += data[1] * 1;
                        }

                        if (phoenix_isInt(data[1]) && data[2]) {
                            cached += data[1] * 1;
                        }

                        if (phoenix_isInt(data[1]) && data[3]) {
                            gzipped += data[1] * 1;
                        }
                    }

                    for (var j = 0; j < css.length; ++j) {
                        var data = phoenix_getFileSize(counter, cache, css[j].replace(/^\@/, ''), true, 'css');

                        if (phoenix_isInt(data[1])) {
                            total_css_size += data[1] * 1;
                        }

                        if (phoenix_isInt(data[1]) && data[2]) {
                            cached += data[1] * 1;
                        }

                        if (phoenix_isInt(data[1]) && data[3]) {
                            gzipped += data[1] * 1;
                        }
                    }

                    cached = cached / (total_js_size + total_css_size) * 100;
                    gzipped = gzipped / (total_js_size + total_css_size) * 100;

                    document.getElementById('phoenix-cached').value = phoenix_getStr('phoenix.cached') + " " + ((phoenix_isInt(Math.round(cached))) ? Math.round(cached) : '0') + "%";
                    document.getElementById('phoenix-gzipped').value = phoenix_getStr('phoenix.gzipped') + " " + ((phoenix_isInt(Math.round(gzipped))) ? Math.round(gzipped) : '0') + "%";
                }
            }
            );


    //    for (var i = 0; i < js.length; ++i) {
    phoenix_getFileSizeAsync(phoenix_array_clone(js), counter, cache, true, 'js');
    //    }

    for (var j = 0; j < css.length; ++j) {
        css[j] = css[j].replace(/^\@/, '');
    }
    phoenix_getFileSizeAsync(phoenix_array_clone(css), counter, cache, true, 'css');
}

// delete caches if the refresh button is hit
function phoenix_refresh(e)
{
    if (e.ctrlKey && (e.keyCode == 116 || e.keyCode == 82)) {
        //get a reference to all dom windows in current page
        var wins = phoenix_getFrames();

        var js = phoenix_getJS(wins);
        if (js.length > 0) {
            for (var i = 0; i < js.length; ++i) {
                var filename = phoenix_getFileName(js[i]);
                Application.storage.set(phoenix_md5('size' + filename), false);
                Application.storage.set(phoenix_md5('cache' + filename), false);
                Application.storage.set(phoenix_md5('gzip' + filename), false);
                Application.storage.set(phoenix_md5('headers' + filename), false);
                Application.storage.set(phoenix_md5('file' + filename), false);
                Application.storage.set(phoenix_md5('packed' + filename), false);
                Application.storage.set(phoenix_md5('minified' + filename), false);
            }
        }

        var css = phoenix_getCSS(wins);
        if (css.length > 0) {
            for (var i = 0; i < css.length; ++i) {
                var filename = phoenix_getFileName(css[i]);
                Application.storage.set(phoenix_md5('size' + filename), false);
                Application.storage.set(phoenix_md5('cache' + filename), false);
                Application.storage.set(phoenix_md5('gzip' + filename), false);
                Application.storage.set(phoenix_md5('headers' + filename), false);
                Application.storage.set(phoenix_md5('file' + filename), false);
                Application.storage.set(phoenix_md5('packed' + filename), false);
                Application.storage.set(phoenix_md5('minified' + filename), false);
            }
        }
    }
}

function phoenix_add_to_url_list(type, url)
{
	if (phoenix_prefs.getIntPref('allowedUrls') == "0")
		var list = 'allowedtextall';

	else
		var list = 'allowedtextnone';

	if (type == "remove")
	{
        var pattern = new RegExp("(^|\\n)" + url + "(\\n|$)");
        var urls = phoenix_prefs.getCharPref(list);
        phoenix_prefs.setCharPref(list, urls.replace(pattern, '\n'));
    }
    else if (type == "add") {
        var cur = phoenix_prefs.getCharPref(list) + "\n" + url;
        phoenix_prefs.setCharPref(list, cur);
    }

    phoenix_load();
}


// https://developer.mozilla.org/en/Adding_preferences_to_an_extension
var phoenixPrefsWatch = {
    prefs: null,

    // Initialize the extension
    startup: function()
    {
        // Register to receive notifications of preference changes
        this.prefs = phoenix_getPrefs();
        this.prefs.QueryInterface(Components.interfaces.nsIPrefBranch2);
        this.prefs.addObserver("", this, false);
    },

    shutdown: function()
    {
        this.prefs.removeObserver("", this);
    },

    observe: function (subject, topic, data)
    {
        if (topic != "nsPref:changed")
            return;

        phoenix_setInitialPrefs();
    }
};


var phoenix_interceptor = {

    observerService : Components.classes["@mozilla.org/observer-service;1"]
            .getService(Components.interfaces.nsIObserverService),

    // adding observer for "http-on-examine-response"
    addObserver : function() {
        phoenix_interceptor.observerService.addObserver(phoenix_interceptor.httpRequestObserver,
                "http-on-examine-response", false);
        //        phoenix_interceptor.observerService.addObserver(phoenix_interceptor.modifyRequestObserver,
        //                "http-on-modify-request", false);
    },

    // removing observer for "http-on-examine-response"
    removeObserver : function() {
        phoenix_interceptor.observerService.removeObserver(phoenix_interceptor.httpRequestObserver,
                "http-on-examine-response", false);
        //        phoenix_interceptor.observerService.removeObserver(phoenix_interceptor.modifyRequestObserver,
        //                "http-on-modify-request", false);
    },

    //    modifyRequestObserver : {
    //        observe: function(subject, topic, data) {
    //            if (topic == "http-on-modify-request") {
    //
    //                var httpChannel = subject.QueryInterface(Components.interfaces.nsIHttpChannel);
    //
    //                httpChannel.setRequestHeader("Cache-Control", "no-cache", false);
    //                httpChannel.setRequestHeader("Cache-Control", "no-store", false);
    //                httpChannel.setRequestHeader("Pragma", "no-cache", false);
    //                httpChannel.setRequestHeader("Expires", "0", false);
    //            }
    //        }
    //    },

    httpRequestObserver : {

        HeaderVisitor : function(headers) {
            this.headers = headers;
        },

        observe: function(aSubject, aTopic, aData) {
            if (aTopic == "http-on-examine-response") {

                if (aSubject.URI == null) {
                    return;
                }

                var url = aSubject.URI.asciiSpec;
                //                phoenix_consoleservice.logStringMessage("### URL: " + url);

                var isJS = url.indexOf(".js") != -1;
                var isCSS = url.indexOf(".css") != -1;

                var httpChannel = aSubject.QueryInterface(Components.interfaces.nsIHttpChannel);

                var isText = false;
                try {
                    //                    phoenix_consoleservice.logStringMessage("### Content-Type: " + httpChannel.getResponseHeader('Content-Type'));
                    if (httpChannel.getResponseHeader('Content-Type').indexOf('text/plain') != -1) {
                        isText = true;
                    }
                } catch (e) {
                    // ignore it
                }

                //                phoenix_consoleservice.logStringMessage("### isText: " + isText);
                if (isText) {
                    var doc = window.content.document;

                    var nodes = doc.evaluate('//script/@src', doc, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);
                    //                    phoenix_consoleservice.logStringMessage("### nodes.snapshotLength: " + nodes.length);

                    for (var i = 0; i < nodes.snapshotLength; i++) {
                        var n = nodes.snapshotItem(i).textContent;
                        //                        phoenix_consoleservice.logStringMessage("### node: " + n);

                        if (n == url) {
                            isJS = true;
                            break;
                        }
                    }
                    //                    phoenix_consoleservice.logStringMessage("### isJS: " + isJS);
                }

                if (isJS || isCSS) {
                    //                    phoenix_consoleservice.logStringMessage("### URL: " + url);

                    //                    var start = phoenix_getMillis(new Date());

                    var cache = phoenix_cache;

                    var simple = 0;
                    var size = '';
                    var cached = false;
                    var gzipped = false;

                    var headers = '';

                    try {
                        if (httpChannel.getResponseHeader('Content-Encoding') == 'gzip') {
                            gzipped = true;
                        }
                    } catch (e) {
                        // ignore it
                    }

                    // For GZipped JS which has no referrer we can't receive minified and packed metrics
                    if (isJS && gzipped && httpChannel.referrer == null) {
                        //                        phoenix_consoleservice.logStringMessage("### OPTIMIZATION CAN'T BE PERFORMED");
                        return;
                    }

                    try {
                        var contentLength = httpChannel.getResponseHeader('Content-Length');
                        if (contentLength) {
                            size = contentLength;
                        }
                    } catch (e) {
                        // ignore it
                    }

                    var headersArray = [];
                    httpChannel.visitResponseHeaders(new phoenix_interceptor.httpRequestObserver.HeaderVisitor(headersArray));

                    headers = headersArray.join("\n");
                    //                    phoenix_consoleservice.logStringMessage("### MAIN headers: " + headers);

                    var file = url;
                    //                    var file = phoenix_getFileName(url);
                    var prepare = true;
                    var simple = parseInt(size);

                    try {
                        entry = cache.openCacheEntry(file, Components.interfaces.nsICache.ACCESS_READ, false);
                        simple = entry.dataSize;
                        size = ' (' + phoenix_formatSize(simple) + ')';
                        Application.storage.set(phoenix_md5('size' + file), simple);
                        cached = true;
                    }
                    catch(e) {

                        if (prepare) {
                            if (phoenix_isInt(simple)) {
                                //                                phoenix_consoleservice.logStringMessage("### MAIN ADDING TO CACHE: " + 'size' + file);
                                size = ' (' + phoenix_formatSize(simple) + ')';
                                Application.storage.set(phoenix_md5('size' + file), simple);
                            }
                        } else {
                            Application.storage.set(phoenix_md5('size' + file), false);
                        }
                    }

                    //                    phoenix_consoleservice.logStringMessage("### gzipped: " + gzipped);
                    Application.storage.set(phoenix_md5('cache' + file), cached);
                    Application.storage.set(phoenix_md5('gzip' + file), gzipped);
                    Application.storage.set(phoenix_md5('headers' + file), headers);

                    if (isJS) {
                        var newListener = new phoenix_TracingListener(contentLength, file);

                        aSubject.QueryInterface(Components.interfaces.nsITraceableChannel);

                        // Add channel listener
                        newListener.originalListener = aSubject.setNewListener(newListener);

                        if (gzipped) {
                            //                            phoenix_consoleservice.logStringMessage("### httpChannel.referrer: " + httpChannel.referrer);

                            if (httpChannel.referrer != null) {
                                var URL = httpChannel.referrer.asciiSpec;
                                //                                phoenix_consoleservice.logStringMessage("### URL: " + URL);

                                var listeners = phoenix_url2gzippedJSInfo[URL];

                                if (listeners == null) {
                                    listeners = [];
                                    phoenix_url2gzippedJSInfo[URL] = listeners;
                                }

                                listeners.push(newListener);
                                //                                phoenix_consoleservice.logStringMessage("### LISTENERS: " + phoenix_url2gzippedJSInfo[URL]);
                            }
                        }
                    }

                    //                    var end = phoenix_getMillis(new Date());
                    //                    phoenix_consoleservice.logStringMessage("### Optimized processing: " + (end - start));
                }
            }
        },

        QueryInterface : function (aIID) {
            if (aIID.equals(Components.interfaces.nsIObserver) ||
                aIID.equals(Components.interfaces.nsISupports)) {
                return this;
            }

            throw Components.results.NS_NOINTERFACE;
        }
    }
};


//<div class="adunit-square">
// <!-- FM Custom 125x125 for HP SMB Zone -->
// <script type='text/javascript' src='http://static.fmpub.net/zone/2159'></script>
// <!-- FM Custom 125x125 for HP SMB Zone -->
//</div>


var phoenix_TracingListener = function(size, file) {
    this.size = size;
    this.file = file;
};

phoenix_TracingListener.prototype = {
    originalListener: null,

    receivedData: "",

    // Helper function for XPCOM instancia tion (from Firebug)
    CCIN : function (cName, ifaceName) {
        return Components.classes[cName].createInstance(Components.interfaces[ifaceName]);
    },

    onDataAvailable: function(request, context, inputStream, offset, count) {

        var binaryInputStream = this.CCIN("@mozilla.org/binaryinputstream;1", "nsIBinaryInputStream");
        var storageStream = this.CCIN("@mozilla.org/storagestream;1", "nsIStorageStream");
        var binaryOutputStream = this.CCIN("@mozilla.org/binaryoutputstream;1", "nsIBinaryOutputStream");

        binaryInputStream.setInputStream(inputStream);

        // Copy received data as they come.
        var data = binaryInputStream.readBytes(count);
        this.receivedData += data;

        var isClosed = false;
        try {
            binaryInputStream.available();
        } catch (e) {
            isClosed = true;
        }

        if (isClosed) {
            if (phoenix_shouldEvalMinified()) {
                phoenix_putDataInCache(this.receivedData);
            }
        }

        storageStream.init(4096, data.length, null);
        binaryOutputStream.setOutputStream(storageStream.getOutputStream(0));

        binaryOutputStream.writeBytes(data, data.length);

        try {
        	this.originalListener.onDataAvailable(request, context, storageStream.newInputStream(0), offset, data.length);
        }
        catch (e) {}
    },

    onStartRequest: function(request, context) {
        this.originalListener.onStartRequest(request, context);
    },

    onStopRequest: function(request, context, statusCode) {
        this.originalListener.onStopRequest(request, context, statusCode);
    },

    QueryInterface: function (aIID) {
        if (aIID.equals(Components.interfaces.nsIStreamListener) ||
            aIID.equals(Components.interfaces.nsISupports)) {
            return this;
        }

        throw Components.results.NS_NOINTERFACE;
    }
};

function phoenix_putDataInCache(code) {
    var minified = false;
    var packed = phoenix_isPacked(code);

    if (!packed) {
        minified = phoenix_isMinified(code);
    }

    Application.storage.set(phoenix_md5('packed' + this.file), packed);
    Application.storage.set(phoenix_md5('minified' + this.file), minified);
}
;

//phoenix_interceptor.httpRequestObserver.cache = phoenix_getCacheService();
phoenix_interceptor.httpRequestObserver.HeaderVisitor.prototype.visitHeader = function(aHeader, aValue) {
    this.headers.push(aHeader + ": " + aValue);
};

phoenix_pageHandler = {
    NOTIFY_STATE_DOCUMENT : Components.interfaces.nsIWebProgress.NOTIFY_STATE_DOCUMENT,
    STATE_STOP : Components.interfaces.nsIWebProgressListener.STATE_STOP,
    STATE_IS_REQUEST   : Components.interfaces.nsIWebProgressListener.STATE_IS_REQUEST,
    STATE_IS_WINDOW    : Components.interfaces.nsIWebProgressListener.STATE_IS_WINDOW,
    STATE_IS_DOCUMENT    : Components.interfaces.nsIWebProgressListener.STATE_IS_DOCUMENT,

    isRequest : function(flag) {
        return (phoenix_pageHandler.STATE_IS_REQUEST & flag) ==
               phoenix_pageHandler.STATE_IS_REQUEST;
    },

    isWindow : function(flag) {
        return (phoenix_pageHandler.STATE_IS_WINDOW & flag) ==
               phoenix_pageHandler.STATE_IS_WINDOW;
    },

    isDocument : function(flag) {
        return (phoenix_pageHandler.STATE_IS_DOCUMENT & flag) ==
               phoenix_pageHandler.STATE_IS_DOCUMENT;
    },

    isStop : function(flag) {
        return (phoenix_pageHandler.STATE_STOP & flag) ==
               phoenix_pageHandler.STATE_STOP;
    },

    registerMyListener : function() {
        gBrowser.addProgressListener(phoenix_pageHandler.myListener, phoenix_pageHandler.NOTIFY_STATE_DOCUMENT);
    },

    unregisterMyListener : function() {
        window.getBrowser().removeProgressListener(phoenix_pageHandler.myListener);
    },

    myListener : {
        onStateChange : function(aProgress, aRequest, aFlag, aStatus) {
            if (phoenix_pageHandler.isStop(aFlag) &&
                phoenix_pageHandler.isWindow(aFlag) &&
                !phoenix_pageHandler.isDocument(aFlag)) {

                phoenix_load();
            }
        },

        onLocationChange:function(aProgress, aRequest, aURI) {
        },
        onProgressChange:function(a, b, c, d, e, f) {
        },
        onStatusChange:function(a, b, c, d) {

        },
        onSecurityChange:function(a, b, c) {
        },

        /*XXX
         This is not nsIWebProgressListenr method,
         just killing a error in tabbrowser.xml
         Maybe a bug.
         */
        onLinkIconAvailable:function(a) {
        }
    }
};

function phoenix_load_wrapper(e) {
    phoenix_load();
}

window.addEventListener("focus", phoenix_load_wrapper, false);

// https://developer.mozilla.org/En/Code_snippets:Tabbed_browser
// ...and here are the preference observer listeners
window.addEventListener("load", function(e) {
    phoenixPrefsWatch.startup();
}, false);
window.addEventListener("unload", function(e) {
    phoenixPrefsWatch.shutdown();
}, false);

window.addEventListener("load", function(e) {
    phoenix_interceptor.addObserver();
    phoenix_pageHandler.registerMyListener();

    gBrowser.tabContainer.addEventListener("TabSelect", phoenix_load_wrapper, false);
}, false);

window.addEventListener("unload", function(e) {
    phoenix_interceptor.removeObserver();
    phoenix_pageHandler.unregisterMyListener();

    gBrowser.tabContainer.removeEventListener("TabSelect", phoenix_load_wrapper, false);
}, false);

// refresh cache if ctrl+f5 or ctrl+R are pressed
window.addEventListener('keypress', phoenix_refresh, true);
