// https://developer.mozilla.org/En/Code_snippets/Preferences

function phoenix_getOptions ()
{
	phoenix_prefs = phoenix_getPrefs ();

	// all these "try" are a ridiculous workaround for a bug i have not managed to investigate yet
	try {
		var chkbxs = document.getElementsByTagName('checkbox');
		for (var i = 0; i < chkbxs.length; ++i)
			chkbxs[i].checked = phoenix_prefs.getBoolPref(chkbxs[i].id);
	}
	catch (e) {}

	try {
		var txtbxs = document.getElementsByTagName('textbox');
		for (var i = 0; i < txtbxs.length; ++i)
			txtbxs[i].value = phoenix_prefs.getCharPref(txtbxs[i].id);
	}
	catch (e) {}

	try {
		var mnulst = document.getElementsByTagName('menulist');
		for (var i = 0; i < mnulst.length; ++i)
			mnulst[i].selectedIndex = phoenix_prefs.getIntPref(mnulst[i].id);
	}
	catch (e) {}

	try {
		var radlst = document.getElementsByTagName('radiogroup');
		for (var i = 0; i < radlst.length; ++i)
		{
			radlst[i].selectedIndex = phoenix_prefs.getIntPref(radlst[i].id);
			phoenix_select_option (phoenix_prefs.getIntPref(radlst[i].id));
		}
	}
	catch (e) {}

	// set options of the "check packed" checkbox
	phoenix_check_packed_option ();
}


function phoenix_saveOptions ()
{
	var chkbxs = document.getElementsByTagName('checkbox');
	for (var i = 0; i < chkbxs.length; ++i)
		phoenix_prefs.setBoolPref(chkbxs[i].id, chkbxs[i].checked);

	var txtbxs = document.getElementsByTagName('textbox');
	for (var i = 0; i < txtbxs.length; ++i)
		phoenix_prefs.setCharPref(txtbxs[i].id, phoenix_options_clean (txtbxs[i].value));

	var mnulst = document.getElementsByTagName('menulist');
	for (var i = 0; i < mnulst.length; ++i)
		phoenix_prefs.setIntPref(mnulst[i].id, parseInt(mnulst[i].selectedIndex));

	var radlst = document.getElementsByTagName('radiogroup');
	for (var i = 0; i < radlst.length; ++i)
		phoenix_prefs.setIntPref(radlst[i].id, parseInt(radlst[i].selectedIndex));

	phoenix_setInitialPrefs ();
	phoenix_test_allowed ();
}


function phoenix_select_option (what)
{
	if (what == "0")
	{
		document.getElementById('allowedtextnone').style.display = "none";
		document.getElementById('allowedtextall').style.display = "block";
	}
	else
	{
		document.getElementById('allowedtextall').style.display = "none";
		document.getElementById('allowedtextnone').style.display = "block";
	}
}


function phoenix_options_clean (str)
{
	str = str.replace(/\n\n/g,"\n");
	return (phoenix_trim (str));
}


function phoenix_check_packed_option ()
{
	if (document.getElementById('checkPackedMinified').checked == true)
		document.getElementById('checkPackedMinifiedMax').disabled = false;

	else
		document.getElementById('checkPackedMinifiedMax').disabled = true;
}


function add_help ()
{
	var userLang = (navigator.language) ? navigator.language : navigator.userLanguage;
    var url = "help/" + userLang + ".txt";
    xmlhttp = new XMLHttpRequest();
    xmlhttp.open('GET', url, true);
    xmlhttp.onreadystatechange = function() {
        if (xmlhttp.readyState == 4) {
	        var help = xmlhttp.responseText;
	        document.getElementById('newhelpSection').value = help;
        }
    };

    xmlhttp.send(null);
    void(0);
}