function phoenix_find (e)
{
	var phoenix_find_code = document.getElementById('phoenixIFrame').contentWindow.document.body.innerHTML;

	var obj = document.getElementById('search');
	phoenix_find_matches = 0;

	if (obj.value.length >= 2) {
		code = phoenix_find_remove_span (phoenix_find_code);

		var newCode = code;
		var bits = obj.value.split(' ');

		var escapeChars = "|<|>|";
		var slashChars = "|.|+|*|(|)|";

		for (var key in bits)
		{
			if (escapeChars.indexOf('|' + bits[key] + '|') != -1)
				bits[key] = escape(bits[key]);

			if (slashChars.indexOf('|' + bits[key] + '|') != -1)
				bits[key] = "\\" + bits[key];
		}

		if (document.getElementById('match_case').checked)
			var match_case = "";
		else
			var match_case = "i";

		var searchText = bits.join("(<[^>]*>)?");

		//var searchText = bits.join("");
		var regx = new RegExp("(" + searchText + "(?!>))", "mg" + match_case);

		var matches = newCode.match(regx);

		//if (matches.length > 0) {
		try {
			phoenix_find_matches = matches.length;

			newCode = newCode.replace(regx, '<span id="search_" class="highlight">$1</span>');

			document.getElementById('find-next').disabled = false;
			document.getElementById('find-prev').disabled = false;

			for (var j = 0; j < phoenix_find_matches; j++) {
				newCode = newCode.replace(/( id\=\"search_\" )/, ' id="search_' + j + '" ');
            }

			document.getElementById('search').className = "find_ok";
			document.getElementById('phoenixIFrame').contentWindow.document.body.innerHTML = newCode;

			phoenix_setup_scroll();
		}

		//else {
		catch (e) {
			document.getElementById('find-next').disabled = true;
			document.getElementById('find-prev').disabled = true;

			document.getElementById('search').className = "find_error";
			document.getElementById('phoenixIFrame').contentWindow.document.body.innerHTML = code;

			phoenix_find_matches = 0;
		}
	} else {
		document.getElementById('find-next').disabled = true;
		document.getElementById('find-prev').disabled = true;

		document.getElementById('search').className = "find_ok";
		document.getElementById('phoenixIFrame').contentWindow.document.body.innerHTML = phoenix_find_remove_span (phoenix_find_code);
	}
}


function phoenix_find_remove_span(code) {
	code = code.replace(/<span[^>]*>/gm, '');
	code = code.replace(/<\/span>/gm, '');

	return (code);
}

function phoenix_setup_scroll() {
	if (phoenix_find_matches > 0) {
		var obj = document.getElementById('phoenixIFrame').contentWindow;
		var tarTop = obj.document.getElementById('search_' + phoenix_find_pointer).offsetTop;
		var tarLeft = obj.document.getElementById('search_' + phoenix_find_pointer).offsetLeft;
		//var cur = obj.body.scrollTop;

		//var viewport = parseInt(phoenix_prefs.getCharPref('height')) - 50 - ((phoenix_prefs.getBoolPref('showErrorConsole')) ? phoenix_prefs.getIntPref('ErrorConsoleHeight') : 0);
		tarLeft = (tarLeft < (parseInt(phoenix_prefs.getCharPref('width')) - 50)) ? 0 : tarLeft;

		//if (((cur + viewport < tarTop) || (cur > tarTop)) && phoenix_find_pointer != 0)
		obj.scrollTo(tarLeft, tarTop);
	}
}

function phoenix_next_find() {
	phoenix_find_pointer++;
	if (phoenix_find_pointer >= phoenix_find_matches)
		phoenix_find_pointer = 0;

	//if (phoenix_find_matches > 0)
	//	phoenix_highlight_find ();

	phoenix_setup_scroll();
}

function phoenix_prev_find() {
	phoenix_find_pointer--;
	if (phoenix_find_pointer < 0)
		phoenix_find_pointer = phoenix_find_matches - 1;

	//if (phoenix_find_matches > 0)
	//	phoenix_highlight_find ();

	phoenix_setup_scroll ();
}

function phoenix_highlight_find () {
	var obj = document.getElementById('phoenixIFrame').contentDocument;
	var elems = phoenix_getElementsByClass ('highlight', obj);
	for (i = 0; i < elems.length; i++)
		elems[i].style.backgroundColor = "orange"

	obj.getElementById('search_' + phoenix_find_pointer).style.backgroundColor = "yellow";
}