/*
 * Phoenix regular expressions for CSS syntax highlighting
 */

// CSS
phoenix_Language.syntax = [
	{ input : /(.*?){(.*?)}/g, output : '<b>$1</b>{<u>$2</u>}' }, // tags, ids, classes, values
	{ input : /([\w-\\]*?):([^\/])/g, output : '<a>$1:</a>$2' }, // keys
	{ input : /\s*\!important/g, output : ' <em>!important</em>' }, // important
	{ input : /\((.*?)\)/g, output : '(<s>$1</s>)' }, // parameters
	{ input : /\/\*(.*?)\*\//g, output : '<i>/*$1*/</i>'} // comments
]

phoenix_Language.snippets = []

phoenix_Language.complete = [
	{ input : '\'',output : '\'$0\'' },
	{ input : '"', output : '"$0"' },
	{ input : '(', output : '\($0\)' },
	{ input : '[', output : '\[$0\]' },
	{ input : '{', output : '{\n\t$0\n}' }
]

phoenix_Language.shortcuts = []
