/*
 * Phoenix regular expressions for HTML syntax highlighting
 */

// HTML
phoenix_Language.syntax = [
	{ input : /(&lt;\!DOCTYPE[^>]*&gt;)/mig, output : '<u>$1</u>'	}, // doctype
	{ input : /&lt;([^!\s]*? )/mig, output : '&lt;<b>$1</b>'	}, // tags
	{ input : / ([^\s=]*)=/mig, output : ' <em>$1</em>=' }, // attributes
	{ input : /=(".*?")/g, output : '=<s>$1</s>' }, // atributes double quote
	{ input : /=('.*?')/g, output : '=<s>$1</s>' }, // atributes single quote
	{ input : /(&lt;!--.*?--&gt.)/mig, output : '<i>$1</i>' } // comments 
]

phoenix_Language.snippets = []
	
phoenix_Language.complete = [
	{ input : '\'',output : '\'$0\'' },
	{ input : '"', output : '"$0"' },
	{ input : '(', output : '\($0\)' },
	{ input : '[', output : '\[$0\]' },
	{ input : '{', output : '{\n\t$0\n}' }		
]

phoenix_Language.shortcuts = []
