/*
 * Phoenix regular expressions for JavaScript syntax highlighting
 */
 
// JavaScript
phoenix_Language.syntax = [ 
	{ input : /\"(.*?)(\"|<br>|<\/P>)/g, output : '<s>"$1$2</s>' }, // strings double quote
	{ input : /\'(.*?)(\'|<br>|<\/P>)/g, output : '<s>\'$1$2</s>' }, // strings single quote
	{ input : /([\{\}\[\]\(\)])/gi, output : '<em>$1</em>' }, // brackets 
	{ input : /\b(anchors|applets|areas|arguments|attributes|Array|body|Boolean|bookmarks|break|case|cells|childNodes|continue|Date|do|document|elements|else|embeds|event|external|false|for|forms|frames|function|history|if|images|links|location|Math|mimeTypes|navigator|new|null|Number|Object|options|plugins|RegExp|rows|return|rules|screen|self|String|switch|tBodies|this|top|true|typeof|undefined|var|void|while|window)\b/gi, output : '<b>$1</b>' }, // reserved words 
	{ input : /\b(abs|accept|acceptCharset|accessKey|acos|action|add|alert|align|aLink|alt|anchor|appCodeName|appendChild|appendData|appName|appVersion|archive|asin|atan|atan2|availHeight|availWidth|axis|back|background|backgroundAttachment|backgroundColor|backgroundImage|backgroundPosition|backgroundRepeat|big|bgColor|blur|bold|border|borderBottom|borderBottomColor|borderBottomStyle|borderBottomWidth|borderCollapse|borderColor|borderLeft|borderLeftColor|borderLeftStyle|borderLeftWidth|borderRight|borderRightColor|borderRightStyle|borderRightWidth|borderStyle|borderTop|borderTopColor|borderTopStyle|borderTopWidth|borderWidth|bottom|bottomMargin|callee|caller|caption|ceil|cellIndex|cellPadding|cellSpacing|ch|charAt|charCodeAt|charset|checked|chOff|cite|classid|className|clear|clearInterval|clearTimeout|click|clip|cloneNode|close|closed|code|codeBase|codeType|color|colorDepth|cols|colSpan|compact|concat|confirm|constructor|content|cookie|coords|cos|createAttribute|createCaption|createComment|createDocumentFragment|createElement|createTextNode|createTFoot|createTHead|cursor|data|dateTime|declare|defaultChecked|defaultSelected|defaultStatus|defaultValue|defer|deleteCaption|deleteCell|deleteData|deleteRow|deleteTFoot|deleteTHead|description|dir|disabled|disableExternalCapture|display|doctype|documentElement|domain|E|elements|embeds|enableExternalCapture|encoding|enctype|exp|face|fgColor|firstChild|fixed|floor|focus|font|fontcolor|fontFamily|fontSize|fontStyle|fontVariant|fontWeight|form|forward|frame|frameBorder|fromCharCode|getAttribute|getAttributeNode|getDate|getDay|getElementById|getElementByName|getElementByTagName|getFullYear|getHours|getMilliseconds|getMinutes|getMonth|getNamedItem|getSeconds|getTime|getTimezoneOffset|getUTCDate|getUTCDay|getUTCFullYear|getUTCHours|getUTCMilliseconds|getUTCMinutes|getUTCMonth|getUTCSeconds|go|handleEvent|hasChildNodes|hasFeatures|hash|headers|height|home|host|hostname|href|hreflang|hspace|htmlFor|httpEquiv|id|implementation|index|innerHTML|innerText|indexOf|input|insertBefore|insertCell|insertData|insertRow|isMap|isNaN|italics|item|javaEnabled|join|label|lang|language|lastChild|lastIndexOf|lastModified|left|length|letterSpacing|lineHeight|link|listStyle|listStyleImage|listStylePosition|listStyleType|LN10|LN2|location|log|LOG10E|LOG2E|longDesc|lowsrc|match|max|maxLength|MAX_VALUE|media|method|min|minHeight|MIN_VALUE|moveTo|multiple|name|namedItem|NaN|NEGATIVE_INIFINITY|nextSibling|nodeName|nodeType|nodeValue|noHref|noResize|normalize|noShade|noWrap|object|onabort|onblur|onchange|onclick|oncontextmenu|ondblclick|ondragdrop|onerror|onfocus|onkeydown|onkeypress|onkeyup|onload|onmousedown|onmouseout|onmouseover|onmouseup|onmove|onreset|onresize|onselect|onsubmit|onunload|open|opener|outerHeight|outerWidth|overflow|ownerDocument|padding|paddingBottom|paddingLeft|paddingRight|paddingTop|pageBreakAfter|pageBreakBefore|pageXoffset|pageYoffset|parent|parentNode|parse|parseFloat|parseInt|pathname|personalbar|PI|pixelDepth|platform|pluginspace|pop|port|POSITIVE_INFINITY|position|pow|previousSibling|print|profile|prompt|protocol|prototype|push|random|readOnly|referrer|refresh|rel|releaseEvents|reload|remove|removeAttribute|removeAttributeNode|removeChild|removeNamedItem|replace|replaceChild|replaceData|reset|resizeTo|rev|reverse|right|round|routeEvent|rowIndex|rows|rowSpan|rubyAlign|rubyOverhang|rubyPosition|rules|scheme|scope|scrollbars|scrollBy|scrolling|scrollTo|search|sectionRowIndex|select|selected|selectedIndex|selectNodeContents|setAttribute|setAttributeNode|setDate|setDay|setFullYear|setHours|setInterval|setMilliseconds|setMinutes|setMonth|setNamedItem|setSeconds|setTime|setTimeout|setUTCDate|setUTCHours|setUTCMilliseconds|setUTCMinutes|setUTCMonth|setUTCSeconds|shape|shift|sin|size|slice|small|span|specified|splice|split|splitText|sort|sqrt|SQRT1_2|SQRT2|src|standby|start|status|statusbar|stop|strike|style|styleFloat|sub|submit|substr|substring|substringData|summary|sup|tabIndex|tableLayout|tagName|taintEnabled|tan|target|text|textAlign|textAutospace|textDecoration|textIndent|textJustify|textKashidaSpace|textOverflow|textTransform|tFoot|tHead|title|toGMTString|toLocaleString|toLowerCase|toolbar|toString|toUpperCase|toUTCString|type|unicodeBidi|units|unwatch|URL|useMap|userAgent|userLanguage|UTC|vAlign|value|valueOf|valueType|version|verticalAlign|visibility|vLink|vlinkColor|volume|vspace|watch|whiteSpace|width|wordSpacing|wordWrap|wrap|write|writeIn|zIndex)\b/gi, output : '<u>$1</u>' }, // special words 
	{ input : /([^:]|^)\/\/(.*?)(<br|<\/li)/g, output : '$1<i>//$2</i>$3' }, // comments //
	{ input : /(?:[^"\/])\/\*([^"])(.*?)\*\//g, output : '<i>/*$1$2*/</i>' } // comments /* */
]

phoenix_Language.snippets = []

phoenix_Language.complete = [
	{ input : '\'',output : '\'$0\'' },
	{ input : '"', output : '"$0"' },
	{ input : '(', output : '\($0\)' },
	{ input : '[', output : '\[$0\]' },
	{ input : '{', output : '{\n\t$0\n}' }		
]

phoenix_Language.shortcuts = []
